function get_polarization(u)
    # u=flatten(u)
    if haskey(u, :E)
        if length(u.E) == 2
            return :TE
        elseif length(u.H) == 2
            return :TM
        end
    else
        if haskey(u, :Hy)
            return :TE
        elseif haskey(u, :Ey)
            return :TM
        end
    end
    nothing
end
function add_current_keys(d)
    # d=OrderedDict
    d = dict(pairs(d))
    add_current_keys!(d)
end
function add_current_keys!(d::AbstractDict)
    for k in keys(d) |> collect
        if startswith(String(k), "E")
            d[Symbol("J" * String(k)[2:end])] = d[k]
        end

        if startswith(String(k), "H")
            d[Symbol("M" * String(k)[2:end])] = d[k]
        end

    end
    d
end
"""
    function setup(boundaries, sources, monitors, L, dx, polarization=nothing; F=Float32)

Args
...
- L: vector of lengths in wavelengths of simulation domain
- polarization: only applies to 2d which can be :TM (Ez, Hx, Hy) or :TE (Hz, Ex, Ey)
"""
function setup(boundaries, sources, monitors, dx, sz;
    polarization=:TE,
    geometry=OrderedDict(),
    # transient_duration=max_source_dist(sources), steady_state_duration=2,
    transient_duration=0, steady_state_duration=0,
    ϵ=1, μ=1, σ=0, σm=0, F=Float32,
    xpml=0.4, ypml=0.4, zpml=0.4,
    # ϵmin=1,
    # Courant=0.5,
    Courant=nothing,
    verbose=true,
    kw...)
    dx, = F.((dx,))

    a = ones(F, Tuple(sz))
    geometry = dict((; ϵ, μ, σ, σm) |> pairs)
    for (k, v) = pairs(geometry)
        if isa(v, Number)
            geometry[k] = a * geometry[k] |> F
        end
    end
    ϵmin, ϵmax = extrema(geometry.ϵ)
    if isnothing(Courant)
        Courant = F(0.8√(ϵmin / length(sz)))# Courant number)
    end

    if transient_duration == 0
        transient_duration = sum(sz) * dx * sqrt(ϵmax) + 4
    end
    if steady_state_duration == 0
        if isempty(monitors)
            steady_state_duration = 4
        else
            v = reduce(vcat, wavelengths.(monitors)) |> Set |> collect |> sort |> reverse
            if length(v) == 1
                steady_state_duration = 4

            else
                steady_state_duration = 20 / minimum(diff([0, (1 ./ v)...]))
            end
        end
    end
    transient_duration, steady_state_duration = F.((transient_duration, steady_state_duration))


    d = length(sz)
    if d == 1
        field_names = (:Ez, :Hy)
        polarization = nothing
    elseif d == 2
        if polarization == :TM
            Enames = (:Ez,)
            Hnames = (:Hx, :Hy)
            field_names = (:Ez, :Hx, :Hy)
        elseif polarization == :TE
            Enames = (:Ex, :Ey)
            Hnames = (:Hz,)
            field_names = (:Ex, :Ey, :Hz)
        end
    else
        polarization = nothing
        Enames = (:Ex, :Ey, :Ez)
        Hnames = (:Hx, :Hy, :Hz)
        field_names = (:Ex, :Ey, :Ez, :Hx, :Hy, :Hz)
    end
    Courant = F(Courant)

    nodes = fill(:U, d, 2)
    pml_depths = [xpml, ypml, zpml]
    db = Any[PML(j * i, pml_depths[i]) for i = 1:d, j = (-1, 1)]
    field_padding = DefaultDict(() -> InPad[])
    geometry_padding = DefaultDict(() -> OutPad[])
    fl = Dict([k => zeros(Int, d) for k = field_names])
    is_field_on_lb = Dict([k => zeros(Int, d) for k = field_names])
    is_field_on_ub = Dict([k => zeros(Int, d) for k = field_names])
    common_left_pad_amount = zeros(Int, d)
    field_sizes = Dict([k => collect(sz) for k = field_names])

    for b = boundaries
        for i = b.dims
            if typeof(b) == Periodic
                db[i, :] = [Periodic(-abs(i)), Periodic(abs(i))]
            else
                if i > 0
                    db[i, 2] = b
                else
                    db[abs(i), 1] = b

                end
            end
        end
    end

    for i = 1:d
        for j = 1:2
            b = db[i, j]
            t = typeof(b)
            if t == PML
            elseif t == PEC
                nodes[i, j] = :E
            elseif t == PMC
                nodes[i, j] = :H
            end
        end
    end

    for i = 1:d
        if nodes[i, :] == [:U, :E]

            nodes[i, 1] = :H
        elseif nodes[i, :] == [:U, :H]

            nodes[i, 1] = :E
        elseif nodes[i, :] == [:E, :U]

            nodes[i, 2] = :H
        elseif nodes[i, :] == [:H, :U]

            nodes[i, 2] = :E
        elseif nodes[i, :] == [:U, :U]

            nodes[i, :] = [:E, :H]
        elseif nodes[i, :] == [:U, :U]

            nodes[i, :] = [:E, :H]
        elseif nodes[i, :] == [:E, :E]

        elseif nodes[i, :] == [:H, :H]

        end

    end



    for i = 1:d
        select = i .== 1:d
        xyz = para = perp = [:x, :y, :z]

        perp = [popat!(para, i)]
        for j = 1:2
            b = db[i, j]
            if isa(b, PML)
                pml_amount = round(Int, b.d / dx)
                l = j == 1 ? [i == a ? pml_amount : 0 for a = 1:d] : zeros(Int, d)
                r = j == 2 ? [i == a ? pml_amount : 0 for a = 1:d] : zeros(Int, d)
                push!(geometry_padding[:ϵ], OutPad(:replicate, l, r, sz))
                push!(geometry_padding[:μ], OutPad(:replicate, l, r, sz))

                l1 = round.(0.2l)
                r1 = round.(0.2r)
                push!(geometry_padding[:σ], OutPad(ReplicateRamp(F(b.σ)), l1, r1, sz))
                push!(geometry_padding[:σm], OutPad(ReplicateRamp(F(b.σ)), l1, r1, sz))
                l2 = l - l1
                r2 = r - r1
                push!(geometry_padding[:σ], OutPad(F(b.σ), l2, r2, sz))
                push!(geometry_padding[:σm], OutPad(F(b.σ), l2, r2, sz))
                if j == 1
                    for k = keys(fl)
                        fl[k][i] += pml_amount
                    end
                    common_left_pad_amount[i] += pml_amount
                end
                for k = keys(field_sizes)
                    field_sizes[k][i] += pml_amount
                end
            end
            l = j == 1 ? Int.((1:d) .== i) : zeros(Int, d)
            r = j == 2 ? Int.((1:d) .== i) : zeros(Int, d)
            t = typeof(b)


            f = nodes[i, j]
            for k = field_names
                q = startswith(String(k), String(f))
                if (q ? k[2] in para : k[2] in perp)
                    if t == Periodic
                        lp = j == 1 ? select : zeros(Int, d)
                        rp = j == 2 ? select : zeros(Int, d)
                        push!(field_padding[k], InPad(:periodic, lp, rp,))
                    else
                        push!(field_padding[k], InPad(0, l, r,))
                    end
                end
            end
        end
    end


    for (k, v) = pairs(field_padding)
        for p = v
            fl[k] += p.l
            is_field_on_lb[k] += p.l
            is_field_on_ub[k] += p.r
        end
    end

    add_current_keys!(fl)
    add_current_keys!(field_sizes)

    field_sizes = NamedTuple([k => Tuple(field_sizes[k]) for (k) = keys(field_sizes)])
    fields = NamedTuple([k => zeros(F, Tuple(field_sizes[k])) for (k) = field_names])
    if d == 1
        pf = u -> [u[1] .* u[2]]
    elseif d == 3
        u0 = dict([
            :E => dict([k => zeros(F, Tuple(field_sizes[k])) for k = (:Ex, :Ey, :Ez)]),
            :H => dict([k => zeros(F, Tuple(field_sizes[k])) for k = (:Hx, :Hy, :Hz)]),
            :J => dict([k => zeros(F, Tuple(field_sizes[k])) for k = (:Jx, :Jy, :Jz)]),
        ])
        # u0 = [u[1:3], u[4:6]]
    else
        if polarization == :TM
            u -> [-u[1] .* u[3], u[2] .* u[1]]
        else
            u0 = dict([
                :E => dict([k => zeros(F, Tuple(field_sizes[k])) for k = (:Ex, :Ey)]),
                :H => dict([k => zeros(F, Tuple(field_sizes[k])) for k = (:Hz,)]),
                :J => dict([k => zeros(F, Tuple(field_sizes[k])) for k = (:Jx, :Jy)]),
            ])
        end
    end

    geometry_sizes = NamedTuple([k => sz .+ sum(geometry_padding[k]) do p
        p.l + p.r
    end for k = keys(geometry_padding)])
    # subpixel_averaging = dict(Pair.(keys(geometry_sizes), Base.oneto.(values(geometry_sizes))))
    subpixel_averaging = Dict{Symbol,Any}()
    field_grids = Dict{Symbol,Any}()
    for k = keys(geometry_sizes)
        if k in (:μ, :σm)
            names = Hnames
        elseif k in (:ϵ, :σ)
            names = Enames
        end
        v = dict([
            begin
                xyz = f[2]
                terminations = zip(is_field_on_lb[f], is_field_on_ub[f])
                g = Symbol("$(k)$xyz$xyz")
                v = SubpixelAveraging(
                    stack([
                        begin
                            if v == (0, 0)
                                [0, 0]
                            elseif v == (0, 1)
                                [0, 0]
                            elseif v == (1, 1)
                                [-1, 1]
                            elseif v == (1, 0)
                                [-1, -1]
                            end
                        end for v in terminations
                    ]))
                if !haskey(field_grids, f)
                    field_grids[f] = v
                end
                g => v
            end for f = names
        ])
        subpixel_averaging[k] = v
    end

    field_origin = NamedTuple([k => (1 - v) * dx / 2 - common_left_pad_amount * dx for (k, v) = pairs(is_field_on_lb)])
    field_origin = add_current_keys(field_origin)

    source_instances = SourceInstance.(sources, dx, (field_sizes,), (field_origin,), (common_left_pad_amount,), (sz,); F)
    monitor_instances = MonitorInstance.(monitors, dx, (field_origin,), (common_left_pad_amount,), (sz,), ; F)
    # roi = MonitorInstance(Monitor(zeros(d), zeros(d), dx * sz), dx, sz, common_left_pad_amount, is_field_on_lb, fl; F)

    dt = dx * Courant
    sz = Tuple(sz)
    for (k, v) = pairs(field_padding)
        a = ones(F, size(fields[k]))
        i = filter(eachindex(v)) do i
            v[i].b == 0
        end
        i_ = sort(setdiff(eachindex(v), i))
        if !isempty(i)

            for i = i
                @unpack b, l, r = v[i]
                pad!(a, b, l, r)
            end
            field_padding[k] = [
                InPad(
                    0,
                    sum(getproperty.(v[i], :l)),
                    sum(getproperty.(v[i], :r)),
                    a),
                v[i_]...
            ]
        end
    end
    geometry_padding = NamedTuple(geometry_padding)
    field_padding = NamedTuple(field_padding)
    if verbose
        @info """
     ====
     FDTD prob
     
     Lengths in characterstic wavelengths, times in characterstic periods, unless otherwise specified

     dx: $(dx|>d2) 
     dt: $(dt|>d2) 
     Courant number: $(Courant|>d2)

     Original array size of all fields in pixels: $sz
     Padded field array field_sizes in pixels:
     $field_sizes
     
     Boundaries:
     $(join("- ".*string.(db),"\n"))
     
     Sources:
     $(join("- ".*string.(sources),"\n"))
     
     Monitors:
     $(join("- ".*string.(monitors),"\n"))
     
     $footer
     ====
     """
    end

    transient_duration, steady_state_duration = F.((transient_duration, steady_state_duration))
    OrderedDict((; geometry_padding, field_padding, subpixel_averaging, field_grids,
        source_instances, monitor_instances, field_names,
        polarization,
        transient_duration, steady_state_duration,
        geometry, n=sqrt(ϵmax),
        # roi,
        u0, fields, d, dx, dt, sz, kw...) |> pairs)
end

update = update
setup = setup

Flux.gpu(d::Dictlike) = apply_func(Flux.gpu, d)
Flux.cpu(d::Dictlike) = apply_func(Flux.cpu, d)

S = Union{MonitorInstance,Collection}
Flux.gpu(v::AbstractVector{T}) where {T<:S} = gpu.(v)
Flux.cpu(v::AbstractVector{T}) where {T<:S} = cpu.(v)
function Flux.cpu(m::MonitorInstance)
    m.wavelength_modes = Flux.cpu(m.wavelength_modes)
    m
end
function Flux.gpu(m::MonitorInstance)
    m.wavelength_modes = Flux.gpu(m.wavelength_modes)
    m
end

function resize(a, sz)
    size(a) != Tuple(sz) && @warn "array size $(size(a)) not same as new size $sz. array will be interpolated"
    imresize(a, sz, method=ImageTransformations.Lanczos4OpenCV())

end
"""
"""
struct ModalSource
    f
    center
    lb
    ub
    normal
    tangent
    # zaxis
    # xaxis
    mode
    label
    meta
    function ModalSource(f, mode, center::Base.AbstractVecOrTuple, normal, tangent, lb, ub, ; label::String="", meta=Dict())
        new(f, center, lb, ub, normal, tangent, E2J(mode), label, meta)
    end
    function ModalSource(f, mode, center::Base.AbstractVecOrTuple, normal, tangent, L, ; label::String="", meta=Dict())
        new(f, center, -L / 2, L / 2, normal, tangent, E2J(mode), label, meta)
    end

end
"""
    function PlaneWave(f, dims; fields...)

Constructs plane wave source

Args
- f: time function
- dims: eg -1 for wave coming from -x face
- fields: which fields to excite & their scaling constants (typically a current source, eg Jz=1)
"""
struct PlaneWave
    f
    fields
    dims
    label
    function PlaneWave(f, dims, label=""; fields...)
        new(f, fields, dims, label)
    end
end
@functor PlaneWave
"""
    function GaussianBeam(f, σ, c, dims; fields...)

Constructs gaussian beam source

Args
- f: time function
- σ: std dev length
- dims: eg 1 for x direction
- fields: which fields to excite & their scaling constants (typically a current source, eg Jz=1)
"""
struct GaussianBeam
    f
    σ
    fields
    c
    dims
    function GaussianBeam(f, σ, c, dims; fields...)
        new(f, σ, fields, c, dims)
    end
end
@functor GaussianBeam

"""
    function Source(f, c, lb, ub, label=""; fields...)
    function Source(f, c, L, label=""; fields...)
        
Constructs custom  source. Can be used to specify uniform or modal sources

Args
- f: time function
- c: origin or center of source
- lb: lower bounds wrt to c
- ub: upper bounds wrt to c
- L: source dimensions in [wavelengths]
- fields: which fields to excite & their scaling constants (typically a current source, eg Jz=1)
"""
struct Source
    f
    fields
    center
    lb
    ub
    label
    meta
    function Source(f, fields, c, lb, ub, label::String=""; kw...)
        new(f, fields, c, lb, ub, label, kw)
    end
    function Source(f, fields, c, L, label::String=""; kw...)
        new(f, fields, c, -L / 2, L / 2, label, kw)
    end
end
# fields(m::Source) = m.fields
Base.string(m::Union{Source,ModalSource}) =
    """
    $(m.label): $(count((m.ub.-m.lb).!=0))-dimensional source, centered at $(m.center|>d2), spanning from $(m.lb|>d2) to $(m.ub|>d2) relative to center,"""
#  exciting $(join(keys(m.fields),", "))"""

function Source(f, c, L, label::AbstractString=""; fields...)
    # Source
    # function Source(f, c, L::Union{AbstractVector{<:Real},Tuple{<:Real}}; fields...)
    Source(f, c, -L / 2, L / 2, label; fields...)
end
Source = Source

struct SourceInstance
    f
    k
    g
    _g
    o
    c
    label
    meta
end
@functor SourceInstance (g, _g,)

function SourceInstance(s::ModalSource, dx, sizes, common_left_pad_amount, fl, sz0; F=Float32)
    @unpack f, center, lb, ub, normal, tangent, meta = s
    C = complex(F)
    J = dict([:Jx => [C(0)], :Jy => [C(0)], :Jz => [C(0)]])
    for k = keys(s.mode)
        J[k] = s.mode[k]
    end
    J = values(J)

    L = ub .- lb
    sz = max.(1, round.(Int, L ./ dx)) |> Tuple
    d = length(lb)
    D = length(center) # 2D or 3D
    if D == 2
        zaxis = [normal..., 0]
        yaxis = [0, 0, 1]
        # xaxis = cross(yaxis, zaxis)
        xaxis = cross(yaxis, zaxis)
        # @show J
        # J = reshape.([Jx, Jy, Jz], (sz,))
    else
        zaxis = normal |> F
        xaxis = tangent |> F
        yaxis = cross(zaxis, xaxis)
    end

    frame = [xaxis, yaxis, zaxis]
    # J = resize.(J, (sz,))
    J = reframe(frame, J)
    if D == 2
        J = [J[:, :, 1] for J in J]
    end
    lb = sum(lb .* frame[1:d])[1:D]
    ub = sum(ub .* frame[1:d])[1:D]
    L = ub - lb

    Jx, Jy, Jz = J
    if D == 2
        fields = (; Jx, Jy)
    else
        fields = (; Jx, Jy, Jz)
    end
    v = zip(lb, ub)
    lb = minimum.(v)
    ub = maximum.(v)
    SourceInstance(Source(f, fields / dx^(D - d), center, lb, ub; meta...), dx, sizes, common_left_pad_amount, fl, sz0; F)
end
function SourceInstance(s::PlaneWave, dx, sizes, common_left_pad_amount, fl, sz0; F=Float32)
    @unpack f, fields, dims, label, meta = s
    _F(x::Real) = F(x)
    _F(x::Complex) = complex(F)(x)
    f = _F ∘ f
    d = length(common_left_pad_amount)
    g = Dict([k => _F(fields[k]) * ones([i == abs(dims) ? 1 : sz0[i] for i = 1:d]...) / dx for k = keys(fields)])
    o = NamedTuple([k =>
        1 .+ fl[k] .+ (dims < 0 ? 0 : [i == abs(dims) ? sizes[k][i] - 1 : 0 for i = 1:d])
                    for k = keys(fl)])
    _g = Dict([k => place(zeros(F, sizes[k]), o[k], g[k],) for k = keys(fields)])
    c = first(values(sizes)) .÷ 2
    SourceInstance(f, keys(fields), g, _g, o, c, label, meta)
end

function SourceInstance(s::GaussianBeam, dx, sizes, fl, stop; F=Float32)
    _F(x::Real) = F(x)
    _F(x::Complex) = complex(F)(x)
    f = _F ∘ f
    @unpack f, σ, fields, c, dims = s
    n = round(Int, 2σ / dx)
    r = n * dx
    r = [i == abs(dims) ? (0:0) : range(-r, r, length=(2n + 1)) for i = 1:length(c)]
    g = [gaussian(norm(F.(collect(v)))) for v = Iterators.product(r...)] / dx
    fl = fl .- 1 .+ index(c, dx) .- round.(Int, (size(g) .- 1) ./ 2)
    _g = place(zeros(F, sz), g, fl)
    SourceInstance(f, keys(fields), g, _g, fl, c, label)
end

function SourceInstance(s::Source, dx, sizes, field_origin, common_left_pad_amount, stop; F=Float32)
    @unpack f, fields, center, lb, ub, label, meta = s
    _F(x::Real) = F(x)
    _F(x::Complex) = complex(F)(x)

    f = _F ∘ f
    g = Dict([k =>
        begin
            if isa(fields[k], AbstractArray)
                # imresize(fields[k], ratio=1)
                sz0 = size(fields[k])
                sz = max.(1, round(abs.(ub - lb) ./ dx)) |> Tuple
                # sz0 != sz && @warn "source array size$sz0 not same  as domain size $sz. source will be interpolated"
                imresize(_F.(fields[k]), sz, method=ImageTransformations.Lanczos4OpenCV())
            else
                r = [a == b ? (a:a) : (a+dx/2*sign(b - a):dx*sign(b - a):b) for (a, b) = zip(lb, ub)]
                [_F.(fields[k](v...)) for v = Iterators.product(r...)]
            end
        end

              for k = keys(fields)])
    o = NamedTuple([k => F((center + lb - o) / dx .+ 1.5) for (k, o) = pairs(field_origin)])
    _g = Dict([k => place(zeros(F, sizes[k]), o[k], g[k],) for k = keys(fields)])
    _center = round(center / dx) + 1 + common_left_pad_amount
    SourceInstance(f, keys(fields), g, _g, o, _center, label, meta)
end

# Complex
apply(v::AbstractVector{<:SourceInstance}, t::Real; kw...) = apply(v, t, kw)
function apply(v::AbstractVector{<:SourceInstance}, t::Real, kw)
    dict([
        # sum([real(s.f(t) .* s._g[k]) for s = v if k in s.k], init=kw[k])
        k => begin

            a = kw[k]
            # gpu = isa(first(v).g, CuArray)
            # if gpu
            #     ignore() do
            #         a = cpu(a)
            #     end
            # end
            for s = v
                if k in s.k
                    mode = s._g[k]
                    # if gpu
                    #     ignore() do
                    #         mode = cpu(mode)
                    #     end
                    # end
                    a += real(s.f(t) .* mode)
                end
            end
            # if gpu
            #     ignore() do
            #         a = gpu(a)
            #     end
            # end
            a
        end
        for k = keys(kw)
        # end for (k, a) = pairs(kw)
    ])
end

# function apply(d,t; kw...)
#     [apply(d[k], kw[k]) for k = keys(kw)]
# end

function E2J(d)
    k0 = filter(k -> string(k)[1] == 'E', keys(d))
    k = [Symbol("J" * string(k)[2:end]) for k in k0]
    v = [d[k] for k in k0]
    dict(Pair.(k, v))
end
function EH2JM(d::T) where {T}
    dict(Pair.(replace(keys(d), :Ex => :Jx, :Ey => :Jy, :Ez => :Jz, :Hx => :Mx, :Hy => :My, :Hz => :Mz), values(d)))
end
# function EH2JM(d::NamedTuple)
#     NamedTuple((d) |> pairs |> OrderedDict |> EH2JM |> pairs)
# end

using LinearAlgebra, UnPack
dl = Dict([
    -1 => "-x"
    1 => "+x"
    -2 => "-y"
    2 => "+y"
    3 => "+z"
    -3 => "-z"
])
"""
    Periodic(dims)

periodic boundary

"""
struct Periodic
    dims
end
Base.string(m::Periodic) = "Periodic on $(dl[m.dims]) side"
"""
PEC(dims)

perfect electrical conductor
dims: eg -1 for -x side
"""
struct PEC
    dims
end
Base.string(m::PEC) = "PEC ON $(dl[m.dims]) side"
"""
PMC(dims)

perfect magnetic conductor
"""
struct PMC
    dims
end
Base.string(m::PMC) = "PMC on $(dl[m.dims]) side"
struct PEMC
    dims
end
Base.string(m::PEMC) = "PEMC on $(dl[m.dims]) side"
"""
function PML(dims, d=0.25f0, σ=20.0f0)
    
    Constructs perfectly matched layers (PML aka ABC, RBC) boundary of depth `d` wavelengths 
    Doesn't need to be explictly declared as all unspecified boundaries default to PML
    """
struct PML
    dims
    d::Real
    σ::Real
    function PML(dims, d=0.5f0, σ=10.0f0)
        new(dims, d, σ)
    end
end
Base.string(m::PML) = "PML of depth $(m.d) on $(dl[m.dims]) side"

struct InPad

    b
    l
    r
    m
    function InPad(b, l, r, m=nothing)
        new(b, l, r, m)
    end
end
@functor InPad (m,)
struct OutPad
    b
    l
    r
    default_size
end
# @functor OutPad


function apply!(p::AbstractVector{<:InPad}, a::AbstractArray)
    for p = p
        @unpack l, r, b, m = p
        if isnothing(m)
            pad!(a, b, l, r;)
        else
            a .= a .* m
        end
    end
    a
end
function apply(p::AbstractVector{<:InPad}, a::AbstractArray)
    if length(p) == 1 && !isnothing(p[1].m)
        return a .* p[1].m
    end

    a_ = Buffer(a)
    # a_ .= a
    a_[axes(a)...] = a
    for p = p
        @unpack l, r, b, m = p
        if isnothing(m)
            pad!(a_, b, l, r;)
        else
            a_[axes(a)...] = a .* m
        end
    end

    copy(a_)
end

function apply(v::AbstractVector{<:OutPad}, x::Real)
    # for p = v
    #     p.b != a && p.b != :replicate && error("cannot pad a constant with different values. it needs to be an array")
    # end
    # a
    # apply(p,)
    apply(v, x * ones(typeof(x), first(v).default_size))
end
function apply(p::AbstractVector{<:OutPad}, a)
    # l = sum(getproperty.(p, :l))
    # r = sum(getproperty.(p, :r))
    # y = Buffer(a, Tuple(l .+ r .+ size(a)))
    # y = place!(y, l .+ 1, a)
    # for p = p
    #     l -= p.l
    #     r -= p.r
    #     y = pad!(y, p.b, p.l, p.r, l, r)
    # end
    # copy(y)
    for p = p
        @unpack l, r, b = p
        a = pad(a, b, l, r)
    end
    a
end

module Luminescent
include("main.jl")
export sandwich
export Periodic, PML, PEC, PMC, InPad, OutPad
export PlaneWave, GaussianBeam, Source
export Monitor, SphereMonitor, power, flux, field, support, sphcoords, inbounds
export setup, apply, apply!, °, update!, update
export calibrate_mode, collapse_mode
export port_number, mode_number, shorten_key, simplify_sparams, sparam_family
export solve, dispersion_compensation
end

# ]add UnPack,StatsBase, DataStructures, LinearAlgebra, Random,  Interpolations, Flux,Zygote, Optim,ArrayPadding, Jello

# gpu(F, x) = F(Flux.gpu(x))
# cpu(F, x) = F(Flux.cpu(x))
using CUDA
using GPUArraysCore
gpu(F, x) = cu(F.(x))
cpu(F, x) = Array(F.(x))

cpu(x::AbstractArray{<:Number}) = cpu(Float32, x)
gpu(x::AbstractArray{<:Number}) = gpu(Float32, x)
gpu(x::AbstractArray) = gpu.(x)
cpu(x::AbstractArray) = cpu.(x)


gpu(x) = isempty(propertynames(x)) ? x : fmap(gpu, x)
cpu(x) = isempty(propertynames(x)) ? x : fmap(cpu, x)

# gpu(v::AbstractVector{<:Collection}) = gpu.(v)
# cpu(v::AbstractVector{<:Collection}) = cpu.(v)

#=
We do inverse design of a compact photonic waveguide bend to demonstrate workflow of FDTD adjoint optimization. First, we seed the design using 2d TE adjoint simulations which serve as fast approximations. Optionlly, we finetune the resulting design in full blown 3d adjoint simulations.

=#

using UnPack, LinearAlgebra, Random, StatsBase, Dates, Colors, DataStructures, JSON, Images
using Zygote, Flux, GLMakie, Jello, ImageTransformations
using Flux: mae, Adam
using Zygote: withgradient, Buffer
using BSON: @save, @load
using AbbreviatedStackTraces
using Rsvg, Cairo, FileIO
# using Jello, Luminescent, LuminescentVisualization
# using Luminescent:keys, values
Random.seed!(1)

# if running directly without module # hide
include("$(pwd())/src/main.jl") # hide
include("$(pwd())/../LuminescentVisualization.jl/src/main.jl") # hide
# using Porcupine: keys, values

if isempty(ARGS)
    path = joinpath(pwd(), "lumi_runs")
    path = filter(isdir, readdir(path, join=true)) |> sort |> last
    PROB_PATH = joinpath(path, "prob.bson")
else
    PROB_PATH = ARGS[1]
    path = dirname(PROB_PATH)

end
#=
We skip 3d finetuning as it's 20x more compute and memory intensive than 2d adjoints. If wishing to do 3d finetuning, set `iterations3d`. In any case, 3d forward simulations (without adjoint) only take a few seconds.
=#
# name = "ubend"
calibrate = false
F = Float32
model_name = nothing # if load saved model
tol = 1e-3
dosave = false
verbose = false
#=
We load design layout which includes a 2d device of device waveguide geometry as well as variables with locations of ports, sources, design regions and material properties.
=#
@load PROB_PATH name runs ports λc dx components study mode_solutions eps_2D eps_3D mode_height zmin gpu
eps_2D = F(stack(stack.(eps_2D)))'
eps_3D = F(permutedims(stack(stack.(eps_3D)), (3, 2, 1)))
# heatmap(eps_2D) |> display
# GLMakie.volume(eps_3D) |> display
# error()
#  ϵbase ϵclad ϵcore hbase hwg hclad
ports, = (ports,) .|> SortedDict
polarization = :TE

_dx = dx / λc
m = round(SOURCE_MARGIN / dx)
source_margin = m * dx
n = round(PORT_SOURCE_OFFSET / dx)
port_source_offset = n * dx
# device = pad(device, :replicate, n)
eps_2D = pad(eps_2D, :replicate, m + n)
eps_3D = pad(eps_3D, :replicate, (m + n, m + n, 0))
origin = components.device.bbox[1] - (m + n) * dx

if study == "inverse_design"
    @load PROB_PATH designs design_region_layer targets iters design_config
    #=
    We initialize a Jello.jl Blob object which will generate geometry of design region. Its parameters will get optimized during adjoint optimization. We initialize it with a straight slab connecting input to output port.
    =#

    model = NamedTuple([
        Symbol("o$i") => begin
            bbox = d.bbox
            L = bbox[2] - bbox[1]
            szd = Tuple(round.(Int, L / dx)) # design region size
            s = d.symmetries
            o = round((bbox[1] - origin) / dx) + 1
            init = 1
            if !isa(init, AbstractArray)
                init = eps_2D[o[1]:o[1]+szd[1]-1, o[2]:o[2]+szd[2]-1]
                # init = init .> (maximum(init) + minimum(init)) / 2
                global init = init .≈ design_config.fill.ϵ |> F
            end
            Blob(szd;
                init,
                lmin=d.lmin / dx,
                contrast=10,
                rmin=nothing,
                symmetries=isempty(s) ? s : s + 1)
        end for (i, d) = enumerate(designs)
    ])
    model = model.m1

    targets = SortedDict([F(λ) => SortedDict([(k) => v for (k, v) = pairs(d)]) for (λ, d) = pairs(targets)])
    # model0 = deepcopy(model)
    # heatmap(model())
end
# Flux.trainable(v::AbstractArray{Blob}) = NamedTuple([Symbol("a$i") => Flux.trainable(model) for (i, model) = enumerate(v)])
# Flux.trainable(model)
# error()
#=
We set boundary conditions, sources , and monitor. The modal source profile is obtained from external mode solver , in our case VectorModesolver.jl . Please refer to guide section of docs website for details . To get an approximate  line source for use in 2d from the cross section profile , we sum and collapse it along its height axis
=#

boundaries = [] # unspecified boundaries default to PML

# monitors = [monitors[1]]

# device, guess,  Δ, ϵbase, ϵcore, ϵclad, dx, λc =
#     F.((device, guess,  Δ, ϵbase, ϵcore, ϵclad, dx, λc))

device = 0
device, dx, λc =
    F.((device, dx, λc))
# guess = F.(guess)

# modal source
runs_sources = [
    begin
        d = run.d
        sources = []
        _modes = []
        for (port, sig) = run.sources |> pairs
            @unpack center, wavelength_mode_numbers = sig
            for λ in keys(wavelength_mode_numbers)
                for mn = wavelength_mode_numbers[λ]
                    λ = F(parse(F, string(λ)))
                    i = findfirst(mode_solutions) do v
                        isapprox(λ, v.wavelength) && string(port) in string.(v.ports)
                    end
                    ms = mode_solutions[i]
                    if !haskey(ms, :calibrated_modes)
                        ms[:calibrated_modes] = Any[nothing for i = eachindex(ms.modes)]
                    end
                    mode = ms[:calibrated_modes][mn+1]
                    if isnothing(mode)
                        mode = ms.modes[mn+1]

                        sz = ms.size
                        eps = ms.eps

                        mode = (; [k => transpose(complex.(stack.(v)...)) |> F for (k, v) in mode |> pairs]...)
                        ϵmode = eps |> stack |> transpose .|> F

                        # sz = round(sz / dx) |> Tuple
                        # # sz = size() - 1
                        # mode = (; Pair.(keys(mode), [resize(v, size(v) - 1) for v in values(mode)])...)
                        # ϵ = resize(ϵ, sz)
                        if d == 2
                            mode, ϵmode = collapse_mode(mode, ϵmode)
                            i = round(Int, size(ϵmode, 1) / 2)
                            ϵcore_ = ϵmode[i]
                            ϵmode = maximum(ϵmode, dims=2) |> vec
                            ϵmode = min.(ϵmode, ϵcore_)
                        end
                        # mode = normalize_mode(mode, dx / λc)
                        mode = keepxy(mode)
                        global mode0 = deepcopy(mode)

                        if calibrate
                            @unpack mode, power = calibrate_mode(mode, ϵmode, dx / λc)
                            # global mode /= sqrt(power)
                            # plot(abs.(mode.Ex)) |> display
                            # plot(abs.(mode0.Ex)) |> display
                            @unpack power, = calibrate_mode(mode, ϵmode, dx / λc;)
                            mode /= sqrt(power)

                            @unpack power, sol = calibrate_mode(mode, ϵmode, dx / λc; verbose=true)
                            GLMakie.save(joinpath(path, "calibration.png"), quickie(sol),)
                            @show power
                            # global mode2 = deepcopy(mode)
                        end

                        # error()
                        ms[:calibrated_modes][mn+1] = mode
                    end
                    # sum(abs.(aa.source_instances[1].g.Jy))
                    # heatmap(abs.(bb.source_instances[1]._g.Jy))
                    n = -sig.normal
                    tangent = [-n[2], n[1]]
                    c = (sig.center - origin + port_source_offset * sig.normal) / λc
                    L = [sig.width] / λc
                    if d == 3
                        L = [L..., mode_height / λc]
                        n, tangent, = vcat.((n, tangent,), ([0],))
                        c = [c..., (ms.zcenter - zmin) / λc]
                    end
                    push!(sources, ModalSource(t -> cispi(2t * λc / λ), mode, c, n, tangent, L; meta=(; port)))

                end
            end
            # sig[:calibrated_modes] = []
        end
        sources
    end for run in runs
]

runs_monitors = [[
    begin
        d = run.d
        port = parse(Int, string(port))
        c = (m.center - origin) / λc
        n = m.normal
        tangent = [-n[2], n[1]]
        L = [m.width] / λc

        if d == 3
            L = [L..., mode_height / λc]
            n, tangent, = vcat.((n, tangent,), ([0],))
        end

        zcenter = nothing
        wavelength_modes = OrderedDict([
            begin
                λ = parse(F, string(λ))
                λ / λc => [
                    begin
                        i = findfirst(mode_solutions) do v
                            isapprox(λ, v.wavelength) && port in v.ports && mn < length(v.modes)
                        end
                        ms = mode_solutions[i]
                        if isnothing(zcenter)
                            zcenter = ms.zcenter
                        end
                        mode = ms.calibrated_modes[mn+1]
                    end for mn = mn
                ]
            end
            for (λ, mn) in pairs(m.wavelength_mode_numbers)
        ])
        if d == 3
            c = [c..., (zcenter - zmin) / λc]
        end
        ModalMonitor(wavelength_modes, c, n, tangent, L; meta=(; port))
    end
    for (port, m) = run.monitors |> pairs] for run in runs]

run_probs = [
    begin
        ϵ = if run.d == 2
            eps_2D
            # heatmap(eps_2D) |> display
        else
            eps_3D
        end
        sz = size(ϵ)
        prob = setup(boundaries, sources, monitors, dx / λc, sz; F, ϵ)
        global bb = prob
    end for (i, (run, sources, monitors)) in enumerate(zip(runs, runs_sources, runs_monitors))
]

if gpu
    CUDA.allowscalar(false)
    @assert CUDA.functional()
    run_probs = gpu.(run_probs)
end

function write_sparams(model=nothing)
    sol = [
        begin

            if !isnothing(model)
                # prob[:geometry] = make_geometry(model)
                # geometry = make_geometry(model)
                # sol = solve(prob, geometry; verbose,)
                sol = solve(prob, model; verbose)
            else
                sol = solve(prob; verbose)
            end

            ignore() do
                try
                    GLMakie.save(joinpath(path, "run$i.png"), quickie(sol),)
                catch e
                    @show e
                end
            end
            sol
        end for (i, prob) in enumerate(run_probs)
    ]

    coeffs = OrderedDict()
    for (v, run) in zip(sol, runs)
        sources = run.sources |> values
        monitors = run.monitors |> values
        source_port = first(values(sources)).port
        source_mn = values(first(values(sources)).wavelength_mode_numbers)[1][1]
        for (monitor, v) = zip(monitors, v.mode_coeffs)
            for (λ, v) = zip(monitor.wavelength_mode_numbers |> keys, v)
                for (monitor_mn, v) = zip(monitor.wavelength_mode_numbers[λ], v)
                    monitor_port = monitor.port
                    if !haskey(coeffs, λ)
                        coeffs[λ] = OrderedDict()
                    end
                    coeffs[λ]["o$monitor_port@$monitor_mn,o$source_port@$source_mn"] = v
                end
            end
        end
    end
    sparams = dict([λ => dict([k => begin
        s = 0
        ignore() do
            s = split(k, ",")[2]
        end
        # k = string(k)
        # i = findfirst(',', string(k))
        # s = string(k)[i+1:length(k)]
        # s = "o1@0"
        coeffs[λ][k][1] / coeffs[λ]["$s,$s"][2]
    end for (k) = keys(coeffs[λ])]) for λ = keys(coeffs)])

    # sparams = OrderedDict([λ => OrderedDict([k => begin
    #     s = split(k, ",")[2]
    #     v[1] / d["$s,$s"][2]
    # end for (k, v) = pairs(d)]) for (λ, d) = pairs(coeffs)])
    # if source_mn == monitor_mn == 0
    #     coeffs[λ]["$monitor_port,$source_port"] = v
    # end
    sparams
end

g0 = run_probs[1].geometry |> deepcopy
# props = keys(g0)
function make_geometry(model)
    # dict([k => begin
    #     a = g0[k]
    #     # a = ones(F, size(g0[k]))
    #     if haskey(design_config.fill, k)
    #         for (m, d) in zip(model, designs)
    #             mask = m()

    #             println(k)
    #             # if k in props

    #             f = design_config.fill[k]
    #             v = design_config.void[k]
    #             # for (f, v) = zip(design_config.fill, design_config.void)
    #             p = (v .* (1 - mask) + f .* mask)
    #             a = place(a, ((d.bbox[1] - origin) / dx) + 1, p; replace=true) |> F
    #             # a = g0[k]
    #             # b = Zygote.Buffer(a)
    #             # copyto!(b, a)
    #             # place!(b, round((d.bbox[1] - origin) / dx) + 1, p |> F)
    #             # g[k] = copy(b)
    #         end
    #     end
    #     a
    # end for k = keys(g0,)])
    mask = model[1]()
    f = design_config.fill.ϵ
    v = design_config.void.ϵ
    # for (f, v) = zip(design_config.fill, design_config.void)
    p = (v .* (1 - mask) + f .* mask)
    a = place(g0.ϵ, ((designs[1].bbox[1] - origin) / dx) + 1, p; replace=true) |> F
    (; ϵ=a, μ=ones(F, size(a)), σ=ones(F, size(a)), σm=ones(F, size(a)))
end
# g = make_geometry(model)
# f, a, pl = heatmap(g[:ϵ])
# f, a, pl = heatmap(p)
# Colorbar(f[1, 2], pl)
# f

function loss(sparams,)# targets)
    # prob[:geometry] = make_geometry(device, ϵ1, ϵ2, model, model_origin)
    mean([mae(abs.(getindex.((yhat,), string.(keys(y)))), values(y).mag) for (y, yhat) = zip(values(targets), values(sparams))])
    # mean([mae(values(yhat),values(y)) for (yhat,y)=zip(targets,[solve(prob;geometry) for prob=run_probs])])
end
function sparam_family(sparams)

    tparams = apply(abs2, sparams)
    sparam_phasors = apply(sparams) do z
        (abs(z), angle(z))
    end
    println(tparams)
    # sparams = apply(reim, sparams)
    sol = (; sparams, tparams, sparam_phasors)
end
if study == "sparams"
    sparams = write_sparams()
    # tparams = dict([k => abs(sparams[k])^2 for k = keys(sparams)])
    # sol = [(; wavelength=λ, sparams=dict([k => reim(v) for (k, v) = pairs(d)])) for (λ, d) = pairs(sparams)]
    sol = sparam_family(sparams)
elseif study == "inverse_design"
    model = model
    # @show loss(model, targets)
    opt = Adam(1)
    opt_state = Flux.setup(opt, model)
    # for i = 1:iters
    for i = 1:5
        println("$i")
        @time global l, (dldm,) = withgradient(model) do m
            sparams = write_sparams([m])
            loss(sparams)
        end
        l < 0 && break
        Flux.update!(opt_state, model, dldm)
        println(" $l\n")
    end
    for (i, (m, d)) = enumerate(zip(model, designs))
        Images.save(joinpath(path, "design$i.png"), Gray.(m() .< 0.5))
    end
    model = model
    sol = (;
        sparam_family(sparams)...,
        designs,

        # model,
        # designs=[m() for m in model],
    )
end
# @save "$path/sol.json" sol
open("$(path)/sol.json", "w") do f
    write(f, json(sol))
end

using Luminescent, Random
Random.seed!(1)
if isempty(ARGS)
    path = lastrun()
    println("path: ", path)
else
    path = ARGS[1]
end
sol = gfrun(path)
# @show sol.tparams

# using Pkg
# pkg"add Porcupine,Jello,ArrayPadding;up"

# using Pkg
# pkg"dev C:\Users\pxshe\OneDrive\Desktop\Porcupine.jl;dev C:\Users\pxshe\OneDrive\Desktop\ArrayPadding.jl; dev C:\Users\pxshe\OneDrive\Desktop\Jello.jl;dev C:\Users\pxshe\OneDrive\Desktop\Luminescent.jl;up"

struct SubpixelAveraging
    v
end

function apply(s::SubpixelAveraging, a::AbstractArray)
    d = ndims(a)
    # for (i, (do_smooth, pad_left, pad_right)) in enumerate(s.v)
    for (i, (l, r)) = enumerate(eachcol(s.v))
        select = i .== (1:d) |> Tuple
        if l == -1
            a = pad(a, :replicate, select, 0)
        end
        if r == 1
            a = pad(a, :replicate, 0, select)
        end
        if l != 0 && r != 0
            # a = conv(a, reshape([1, 1], 1 + select)) / 2
            a = (2selectdim(a, i, 1:(size(a, i)-1)) + diff(a, dims=i)) / 2
        end
        if l == 0 && r == 0
            a += 0
        end
    end
    a
end

using DiffEqFlux, DifferentialEquations, ArrayPadding
include("del.jl")

dx = 1 / 16.0f0
lx = ly = lz = 4.0f0
dims = round(Int, [lx, ly, lz] / dx)

ϵ = ones(dims)
μ = ones(dims)
σ = zeros(dims)

u0 = zeros(dims..., 6)
τ = 1.0f0
f(t) = exp(-((t - τ))^2)
datasize = 8
tspan = (0.0f0, 6.0f0)
tsteps = range(tspan[1], tspan[2], length=datasize)

function trueODEfunc(du, u, p, t)
    Ex, Ey, Ez, Hx, Hy, Hz = eachslice(u)

    Ex = cat(zeros(dims[2:3]), Ex, dims=3)
    Ey = cat(zeros(dims[2:3]), Ey, dims=3)
    Ez = cat(f(t) * ones(dims[2:3]), Ez, dims=3)

    Hx = cat(zeros(dims[2:3]), Hx, dims=3)
    Hy = cat(zeros(dims[2:3]), Hy, dims=3)
    Hz = cat(zeros(dims[2:3]), Hz, dims=3)

    Ex = pad(Ex, :periodic, (0, 1, 1), (0, 0, 0))
    Ey = pad(Ey, :periodic, (0, 1, 1), (0, 0, 0))
    Ez = pad(Ez, :periodic, (0, 1, 1), (0, 0, 0))
    Hx = pad(Hx, :periodic, (0, 0, 0), (0, 1, 1),)
    Hy = pad(Hy, :periodic, (0, 0, 0), (0, 1, 1),)
    Hz = pad(Hz, :periodic, (0, 0, 0), (0, 1, 1),)


    true_A = [-0.1 2.0; -2.0 -0.1]
    du .= ((u .^ 3)'true_A)'
end

prob_trueode = ODEProblem(trueODEfunc, u0, tspan)
ode_data = Array(solve(prob_trueode, Tsit5(), saveat=tsteps))

using Luminescent, Random

Random.seed!(1)
if isempty(ARGS)
    path = lastrun()
    println("path: ", path)
else
    path = ARGS[1]
end
# gfrun(path)
function write_sparams(runs, run_probs, g, path, origin, dx,
    designs=nothing, design_config=nothing, models=nothing;
    img=nothing, autodiff=true, verbose=false, kw...)
    F = run_probs[1].F
    if !isnothing(models)
        geometry = make_geometry(models, origin, dx, g, designs, design_config; F)
    end
    sol = [
        begin
            if !isnothing(models)
                prob[:geometry] = geometry
            end
            @show typeof(prob.u0.E.Ex), typeof(prob.geometry.ϵ)
            sol = solve(prob; autodiff, verbose, cpu, gpu)

            ignore() do
                if !isnothing(img)
                    if img == ""
                        img = "run$i.png"
                    end
                    try
                        CairoMakie.save(joinpath(path, img), quickie(sol |> cpu),)
                    catch e
                        println(e)
                    end
                end
            end
            sol
        end for (i, prob) in enumerate(run_probs)
    ]
    # return sol
    coeffs = OrderedDict()
    for (v, run) in zip(sol, runs)
        sources = run.sources |> values
        monitors = run.monitors |> values
        source_port = first(values(sources)).port
        source_mn = values(first(values(sources)).wavelength_mode_numbers)[1][1]
        for (monitor, v) = zip(monitors, v.mode_coeffs)
            for (λ, v) = zip(monitor.wavelength_mode_numbers |> keys, v)
                for (monitor_mn, v) = zip(monitor.wavelength_mode_numbers[λ], v)
                    monitor_port = monitor.port
                    if !haskey(coeffs, λ)
                        coeffs[λ] = OrderedDict()
                    end
                    coeffs[λ][("o$monitor_port@$monitor_mn,"*"o$source_port@$source_mn")] = v
                end
            end
        end
    end

    sparams = OrderedDict([λ => OrderedDict([k => begin
        s = ignore() do
            split(k, ",")[2]
        end
        coeffs[λ][k][1] / coeffs[λ]["$s,$s"][2]
    end for (k) = keys(coeffs[λ])]) for (λ) = keys(coeffs)])
    # if source_mn == monitor_mn == 0
    #     coeffs[λ]["$monitor_port,$source_port"] = v
    # end
    sparams
end
# targets = SortedDict([F(λ) =>
#     OrderedDict([
#         begin
#             a, b = split(string(k), ",")
#             (a, b) => F(v)
#         end
#         for (k, v) = pairs(d)
#     ]) for (λ, d) = pairs(targets)])
# g0 = (; ϵ=eps_2D, μ=ones(F, size(eps_2D)), σ=zeros(F, size(eps_2D)), σm=zeros(F, size(eps_2D)))
function make_geometry(models, origin, dx, g0, designs, design_config; F=Float32)
    g = deepcopy(g0)
    dict([k => begin
        a = g[k]
        if haskey(design_config.fill, k)
            for (m, d) in zip(models, designs)
                mask = m()
                f = design_config.fill[k] |> F
                v = design_config.void[k] |> F
                # for (f, v) = zip(design_config.fill, design_config.void)
                T = typeof(a)
                p = (v .* (1 - mask) + f .* mask) |> F |> T
                # a = place(a, ((d.bbox[1] - origin) / dx) + 1, p; replace=true) |> F
                b = Zygote.Buffer(a)
                copyto!(b, a)
                place!(b, round((d.bbox[1] - origin) / dx) + 1, p)
                a = copy(b)
            end
        end
        a
    end for k = keys(g,)])
end
function loss(params, targets)
    # mean([mae(getindex.((yhat,), string.(keys(y))), values(y)) for (y, yhat) = zip(values(targets), values(params))])
    mean([
        sum(zip(getindex.((yhat,), string.(keys(y))), values(y))) do (yhat, y)
            r = y - yhat
            if y == 1
                r
            else
                abs(r)
            end
        end for (y, yhat) = zip(values(targets), values(params))
    ])
    # mean([mae(values(yhat),values(y)) for (yhat,y)=zip(targets,[solve(prob;geometry) for prob=run_probs])])
end


using BSON: @load, @save, load
using BSON, Statistics, DataStructures, Porcupine, ArrayPadding, UnPack, Jello, JSON, Flux, CUDA, Zygote
using Luminescent: gpu, cpu
using Porcupine: values, keys, fmap
using CUDA: @allowscalar
println("setting up simulation...")
# do something based on ARGS?
PROB_PATH = joinpath(path, "prob.bson")

calibrate = true
model_name = nothing # if load saved model
tol = 1e-3
dosave = false
verbose = false
#=
We load design layout which includes a 2d device of device waveguide geometry as well as variables with locations of ports, sources, design regions and material properties.
=#
@load PROB_PATH name dtype margin source_margin Courant port_source_offset portsides runs ports dx components study mode_solutions eps_2D eps_3D mode_height zmin gpu_backend d
F = Float32
if contains(dtype, "16")
    F = Float16
    println("Float16 selected. make sure your cpu or GPU supports it. otherwise will be emulated and very slow.")
    # println("Float16 not supported yet, will be in future release.")
end
λc = median(load(PROB_PATH)[:wavelengths])
eps_2D = F(stack(stack.(eps_2D)))'
eps_3D = F(permutedims(stack(stack.(eps_3D)), (3, 2, 1)))
# heatmap(eps_2D) |> display
# GLMakie.volume(eps_3D) |> display
# error()
#  ϵbase ϵclad ϵcore hbase hwg hclad
ports, = (ports,) .|> SortedDict
polarization = :TE

# _dx = dx / λc
port_source_offset = whole(port_source_offset, dx)
margin = whole(margin, dx)
source_margin = whole(source_margin, dx)

p = round((port_source_offset + source_margin) / dx)
np = round(margin / dx)
# p = m + n
# origin = components.device.bbox[1] - dx * p
# eps_3D = pad(eps_3D, :replicate, [p, p, 0])
# eps_2D = pad(eps_2D, :replicate, p)
models = nothing
lr = p * portsides + np * (1 - portsides)
eps_2D = pad(eps_2D, :replicate, lr...)
# nz=whole(ZMARGIN,_dx)
push!(lr[1], 0)
push!(lr[2], 0)
eps_3D = pad(eps_3D, :replicate, lr...)
# heatmap(eps_2D) |> display
origin = components.device.bbox[1] - dx * (p * portsides[1] + np * (1 - portsides[1]))
if study == "inverse_design"
    @load PROB_PATH designs targets target_type eta iters design_config
    prob = load(PROB_PATH)
    minloss = haskey(prob, :minloss) ? prob[:minloss] : -Inf

    models = [
        # Symbol("o$i") =>
        begin
            @unpack init, bbox = d
            L = bbox[2] - bbox[1]
            szd = Tuple(round.(Int, L / dx)) # design region size
            symmetries = [length(string(s)) == 1 ? Int(s) + 1 : s for s = d.symmetries]
            o = round((bbox[1] - origin) / dx) + 1
            # if !isa(init, AbstractArray)
            # if init == ""
            if isnothing(init)
                init = eps_2D[o[1]:o[1]+szd[1]-1, o[2]:o[2]+szd[2]-1]
                # init = init .> (maximum(init) + minimum(init)) / 2
                init = init .≈ design_config.fill.epsilon |> F
            elseif init == "random"
                init = nothing
            end
            lmin = d.lmin / dx
            Blob(szd;
                init, lmin, rmin=lmin / 4,
                contrast=10,
                symmetries, verbose)
        end for (i, d) = enumerate(designs)
    ]

    # model0 = deepcopy(model)
    # using CairoMakie
    # heatmap(model[1]())
end

boundaries = [] # unspecified boundaries default to PML

device = 0
device, dx, λc =
    F.((device, dx, λc))
# guess = F.(guess)
for ms = mode_solutions
    if !haskey(ms, :calibrated_modes)
        ms[:calibrated_modes] = []
    end
    for (mode, mode1) in zip(ms.modes, ms.modes1)

        sz = ms.size
        eps = ms.eps
        #  ϵmode1=   eps1 = ms.eps1

        mode = (; [k => complex.(stack.(v)...) |> F for (k, v) in mode |> pairs]...)
        mode1 = (; [k => complex.(v...) |> F for (k, v) in mode1 |> pairs]...)
        # ϵmode = eps |> stack |> transpose .|> F

        # sz = round(sz / dx) |> Tuple
        # # sz = size() - 1
        # mode = (; Pair.(keys(mode), [resize(v, size(v) - 1) for v in values(mode)])...)
        # ϵ = resize(ϵ, sz)
        if d == 2
            mode = mode1
            # mode, ϵmode = collapse_mode(mode, ϵmode)
            # i = round(Int, size(ϵmode, 1) / 2)
            # ϵcore_ = ϵmode[i]
            # ϵmode = maximum(ϵmode, dims=2) |> vec
            # ϵmode = min.(ϵmode, ϵcore_)
        end
        # mode = normalize_mode(mode, dx / λc)
        mode = keepxy(mode)
        # global mode0 = deepcopy(mode)

        if calibrate && d == 2
            # @unpack mode, power = calibrate_mode(mode, ϵmode, dx / ms.wavelength)
            # global mode /= sqrt(power)
            # @unpack power, = calibrate_mode(mode, ϵmode, dx / λc;)
            # mode /= sqrt(power)

            # @unpack power, sol = calibrate_mode(mode, ϵmode, dx / λc; verbose=true)
            # MyMakie.save(joinpath(path, "calibration.png"), quickie(sol),)
            # @show power
            # global mode2 = deepcopy(mode)
        end

        # error()
        push!(ms[:calibrated_modes], mode)
    end
end

# modal source
runs_sources = [
    begin
        d = run.d
        sources = []
        _modes = []
        for (port, sig) = run.sources |> pairs
            @unpack center, wavelength_mode_numbers = sig
            for λ in keys(wavelength_mode_numbers)
                for mn = wavelength_mode_numbers[λ]
                    λ = F(parse(F, string(λ)))
                    i = findfirst(mode_solutions) do v
                        isapprox(λ, v.wavelength) && string(port) in string.(v.ports)
                    end
                    ms = mode_solutions[i]
                    mode = ms.calibrated_modes[mn+1]
                    # sum(abs.(aa.source_instances[1].g.Jy))
                    # heatmap(abs.(bb.source_instances[1]._g.Jy))
                    n = -sig.normal
                    tangent = [-n[2], n[1]]
                    c = (sig.center - origin + port_source_offset * sig.normal) / λc
                    L = [sig.width] / λc
                    if d == 3
                        L = [L..., mode_height / λc]
                        n, tangent, = vcat.((n, tangent,), ([0],))
                        c = [c..., (ms.zcenter - zmin) / λc]
                    end
                    push!(sources, ModalSource(t -> cispi(2t * λc / λ), mode, c, n, tangent, L; meta=(; port)))

                end
            end
            # sig[:calibrated_modes] = []
        end
        sources
    end for run in runs
]

runs_monitors = [[
    begin
        d = run.d
        port = parse(Int, string(port))
        c = (m.center - origin) / λc
        n = m.normal
        tangent = [-n[2], n[1]]
        L = [m.width] / λc

        if d == 3
            L = [L..., mode_height / λc]
            n, tangent, = vcat.((n, tangent,), ([0],))
        end

        zcenter = nothing
        wavelength_modes = SortedDict([
            begin
                λ = parse(F, string(λ))
                λ / λc => [
                    begin
                        i = findfirst(mode_solutions) do v
                            isapprox(λ, v.wavelength) && port in v.ports && mn < length(v.modes)
                        end
                        ms = mode_solutions[i]
                        if isnothing(zcenter)
                            zcenter = ms.zcenter
                        end
                        mode = ms.calibrated_modes[mn+1]
                    end for mn = mn
                ]
            end
            for (λ, mn) in pairs(m.wavelength_mode_numbers)
        ])
        if d == 3
            c = [c..., (zcenter - zmin) / λc]
        end
        ModalMonitor(wavelength_modes, c, n, tangent, L; meta=(; port))
    end
    for (port, m) = run.monitors |> pairs] for run in runs]

run_probs = [
    begin
        ϵ = if run.d == 2
            eps_2D
            # heatmap(eps_2D) |> display
        else
            eps_3D
        end
        sz = size(ϵ)
        ϵmax = maximum(ϵ)
        μ = 1
        σ = PML(1).σ
        δ = sqrt(ϵmax / μ) / σ
        setup(boundaries, sources, monitors, dx / λc, sz; F, Courant, ϵ,
            pml_depths=[δ, δ, 0.3δ,],
            pml_ramp_fracs=[0.2, 0.2, 1],
            verbose,)
    end for (i, (run, sources, monitors)) in enumerate(zip(runs, runs_sources, runs_monitors))
]

if !isempty(gpu_backend)
    println("using $gpu_backend backend.")
    Flux.gpu_backend!(gpu_backend)
    if gpu_backend == "CUDA"
        # study == "inverse_design" && CUDA.allowscalar(true)
        @assert CUDA.functional()
        # elseif gpu_backend == "AMDGPU"
        #     using AMDGPU
        # elseif gpu_backend == "Metal"
        #     using Metal
    end
    run_probs = gpu.(run_probs)
    # models = models |> gpu
else
    println("using CPU backend.")
end
g0 = run_probs[1].geometry |> deepcopy

virgin = true
# error()

t0 = time()
if study == "sparams"
    # @info "Computing s-parameters..."
    println("Computing s-parameters...")
    # sparams = write_sparams(img="", autodiff=false, verbose=true)
    sparams = write_sparams(runs, run_probs, g0, path, origin, dx;
        F, img="", autodiff=true, verbose=true)
    sol = sparam_family(sparams)
elseif study == "inverse_design"
    sparams0 = 0
    # @show write_sparams(model)
    opt = Adam(eta)
    model = models[1]
    opt_state = Flux.setup(opt, model)
    Flux.freeze!(opt_state.w)
    # opt_state=(;a=opt_state.a)
    # @info "starting optimization... first iter will be slow due to compilation."
    println("starting optimization... first iter will be slow due to adjoint compilation.")
    stop = false
    img = nothing
    best = Inf
    for i = 1:iters
        global virgin, stop, best, best0, sparams0
        img = if virgin
            virgin = false
            "before.png"
        elseif i == iters || stop
            "after.png"
        else
            img
        end
        # a = Params(model)
        # @time global l, (dldm) = Flux.withgradient(Params(model)) do
        @time global l, (dldm,) = Flux.withgradient(model) do m
            sparams = write_sparams(runs, run_probs, g0, path, origin, dx,
                designs, design_config, [m];
                F, img, autodiff=true)
            params = if target_type == "sparams"
                sparams
            else
                Porcupine.apply(abs2, sparams)
            end
            loss(params, targets)
            # abs(sparams[1].mode_coeffs[2][1][1][1])

        end
        # dldm = getindex.((dldm,), model)
        if stop
            break
        end
        if i == 1
            best0 = best = l
        end
        # if !isempty(gpu_backend)
        #     dldm = gpu(dldm)
        # end
        # dldm = NamedTuple([k => (k == :a ? v : nothing) for (k, v) in pairs(dldm)])
        global w0 = deepcopy(Array.(model.w))

        Flux.update!(opt_state, model, dldm)# |> gpu)
        # w = cu.(w0)
        # model.w = cu.(w0)
        # error()
        if l < best
            best = l
        end
        if l < minloss
            println("Loss below threshold, stopping optimization.")
            stop = true
            img = "after.png"
        end
        if i % 15 == 0
            if best - best0 > -0.01
                println("Loss stagnating, stopping optimization.")
                stop = true
            else
                best0 = best
            end
        end
        println("$i loss $l\n")
    end
    # @info "Done in $(time() - t0) ."
    println("Done in $(time() - t0) .")
    for (i, (m, d)) = enumerate(zip(models, designs))
        Images.save(joinpath(path, "design$i.png"), Gray.(m() .< 0.5))
    end
    sol = (;
        before=sparam_family(sparams0),
        after=sparam_family(sparams),
        optimized_designs=[m() .> 0.5 for m in models],
        designs,
        design_config,
    )
end
sol = (; sol..., path, dx, study,)
# @save "$path/sol.json" sol
open("$(path)/sol.json", "w") do f
    write(f, json(sol))
end
sol

abstract type AbstractMonitor end
struct Monitor <: AbstractMonitor
    c
    lb
    ub
    n
    tangent
    label

    wavelength_modes
    meta
end

wavelengths(m::Monitor) = keys(m.wavelength_modes)
struct PointCloudMonitor <: AbstractMonitor
    p
    n
    w
    c
    s
    sz
    label
end
sphcoords(m::PointCloudMonitor) = m.s
normal(m::AbstractMonitor) = m.n

"""
    function Monitor(c, L; normal=nothing, label="")
    function Monitor(c, lb, ub; normal=nothing, label="")

Constructs monitor which can span a point, line, surface, volume or point cloud monitoring fields or power. 

Args
- c: origin or center of monitor
- L: physical dimensions of monitor
- lb: lower bounds wrt to c
- ub: upper bounds wrt to c

- normal: flux monitor direction (eg normal to flux surface)
"""
function Monitor(c, L, normal=nothing; label="", kw...)
    Monitor(c, -L / 2, L / 2, normal, label, nothing, kw)
end

function ModalMonitor(wavelength_modes::Dictlike, c, normal, tangent, L; wavelength=1, wavelengths=[wavelength], label="", kw...)
    if isa(first(values(wavelength_modes)), AbstractArray{<:Number})
        wavelength_modes = dict([1 => [wavelength_modes]])
    end
    Monitor(c, -L / 2, L / 2, normal, tangent, label, wavelength_modes, kw)
end
# function ModalMonitor(mode, a...; kw...)
#     # if 
#     # ModalMonitor(, a...; kw...)
# end


Monitor(p::AbstractMatrix; normals=nothing, weights=nothing, label="") = PointCloudMonitor(p, normals, weights, mean(p, dims=2), nothing, nothing, label)

Monitor(v::AbstractVector; kw...) = Monitor(Matrix(v); kw...)
# Spherical monitor center `c` radius `r` commonly used for antenna pattern . Instantiated to `PointCloudMonitorInstance` consisting of `N` points uniformly sampled on sphere. Points outside simulation domain are automatically discarded 
# function SphereMonitor(c, r; N=256, label="")
"""
    function SphereMonitor(c, r; dθ=5°, dϕ=5°, label="")

Spherical monitor center `c` radius `r` commonly used for antenna pattern . Instantiated to `PointCloudMonitorInstance` . Points outside simulation domain are automatically discarded 
    """
function SphereMonitor(c, r; dθ=2°, dϕ=2°, N=256, nθ=36, nϕ=18, label="")
    # n = stack(sample(Sphere((0, 0, 0), 1), HomogenousSampling(N)))\
    θlims = (0, 360°)
    ϕlims = (0, 180°)
    θ = range(θlims...; step=dθ)
    ϕ = range(ϕlims...; step=dϕ)
    nθ = length(θ)
    nϕ = length(ϕ)
    samples = getproperty.(sample(Sphere((0, 0, 0), 1), RegularSampling(nθ, nϕ)) |> collect, :coords)
    # samples = getproperty.(sample(Sphere((0, 0, 0), 1), HomogeneousSampling(N)) |> collect, :coords)
    # samples=Base.product(θ,ϕ)
    sz = (nθ, nϕ)
    n = stack(samples)
    p = c .+ n * r
    t = SphericalFromCartesian()
    s = stack([[sph.r, sph.θ, sph.ϕ] for sph = t.(samples)])
    # A = 4π * r^2
    # w = A / N
    # w = map(CartesianIndices(sz)) do i, j
    w = map(samples) do (θ, ϕ)
        r^2 * dθ * dϕ * sin(ϕ)
    end
    PointCloudMonitor(p, n, w, c, s, sz, label)
end
Base.string(m::Monitor) =
    """
    $(m.label): $(count((m.ub.-m.lb).!=0))-dimensional monitor, centered at $(m.c|>d2), physical size of $((m.ub-m.lb)|>d2) relative to center, flux normal towards $(normal(m)|>d2)"""
Base.string(m::PointCloudMonitor) =
    """
    $(m.label): point cloud monitor, centered at $(m.c|>d2), $(size(m.p,2)) points"""

abstract type AbstractMonitorInstance end
mutable struct MonitorInstance <: AbstractMonitorInstance
    d
    roi
    frame
    dx
    v
    center
    label

    wavelength_modes
end
@functor MonitorInstance (wavelength_modes,)
Base.ndims(m::MonitorInstance) = m.d
Base.size(m::MonitorInstance) = length.(m.i)
area(m::MonitorInstance) = m.v

struct PointCloudMonitorInstance <: AbstractMonitorInstance
    i
    roi
    n
    w
    c
    inbounds
    label
end
inbounds(m::PointCloudMonitorInstance) = m.inbounds
Base.length(m::MonitorInstance) = 1
Base.length(m::PointCloudMonitorInstance) = 1

frame(m::MonitorInstance) = m.frame
normal(m::MonitorInstance) = frame(m)[3][1:length(m.center)]

function MonitorInstance(m::Monitor, dx, field_origin, common_left_pad_amount, sz, ; F=Float32)
    @unpack n, lb, ub, c, tangent, wavelength_modes, = m
    n, lb, ub, c, tangent = F.((n, lb, ub, c, tangent))
    L = ub - lb
    D = length(c)
    d = length(lb)
    A = isempty(L) ? 0 : prod(L,)
    if D == 2
        frame = [[-n[2], n[1], 0], [0, 0, 1], [n..., 0]]

    elseif D == 3
        frame = [tangent, n × tangent, n]
    end
    lb = sum(lb .* frame[1:d])[1:D]
    ub = sum(ub .* frame[1:d])[1:D]
    v = zip(lb, ub)
    lb = minimum.(v)
    ub = maximum.(v)
    L = ub - lb

    roi = dict([k => begin
        p = (c + lb - o) / dx + 1.5
        i = floor(p)
        w = 1 - mean(abs.(p - i))
        w = (w, 1 - w)
        i = [i .+ map(round(L / dx)) do n
            n == 0 ? 0 : (0:sign(n):n-sign(n))
        end for i = (i, i + 1)]
        [(F(w), i) for (w, i) in zip(w, i) if w > 0]
    end for (k, o) = pairs(field_origin)])
    n = isnothing(n) ? n : F.(n |> normalize)
    _center = round(c / dx) + 1 + common_left_pad_amount
    MonitorInstance(d, roi, frame, F(dx), F(A), _center, m.label, wavelength_modes)
end

function MonitorInstance(m::PointCloudMonitor, dx, sz, common_left_pad_amount, flb, fl; F=Float32)
    @unpack p, n, c, w, label = m
    p = round.(p / dx) .+ 1
    _, i = size(p)
    inbounds = filter(1:i) do i
        v = p[:, i]
        all(v .> 0) && all(v .<= sz)
    end
    p = p[:, inbounds]
    n = n[:, inbounds]
    # p = stack(@. v[1])
    # n = stack(@. v[2])
    i = p .+ common_left_pad_amount
    roi = NamedTuple([k => p .+ v for (k, v) = pairs(fl)])
    c = round.(c / dx) .+ 1 + common_left_pad_amount
    PointCloudMonitorInstance(i, roi, F.(n), w, c, inbounds, label)
end

"""
    function field(u, k, m)
    
queries field, optionally at monitor instance `m`

Args
- `u`: state
- `k`: symbol or str of Ex, Ey, Ez, Hx, Hy, Hz, |E|, |E|2, |H|, |H|2
- `m`
"""
function field(u, k, m=nothing)
    if k == "|E|2"
        sum(field.(u, (:Ex, :Ey, :Ez), (m,))) do a
            a .^ 2
        end
    elseif k == "|E|"
        sqrt.(field(u, "|E|2", m))
    elseif k == "|H|2"
        sum(field.(u, (:Hx, :Hy, :Hz), (m,))) do a
            a .^ 2
        end
    elseif k == "|H|"
        sqrt.(field(u, "|H|2", m))
    else
        a = u(k)
        if isnothing(m)
            return a
        elseif isa(m, MonitorInstance)
            return sum([w * a[i...] for (w, i) = m.roi[k]])
        elseif isa(m, PointCloudMonitorInstance)
            return [a[v...] for v = eachcol(m.roi[k])]
        end
    end
end

Base.getindex(a, k, m::MonitorInstance) = field(a, k, m)

"""
    function flux(m::MonitorInstance, u)

 Poynting flux profile passing thru monitor 
"""
function flux(u, m::MonitorInstance)
    d = ndims(m)
    E = [u[k, m] for k = keys(u[:E])]
    H = [u[k, m] for k = keys(u[:H])]

    # (E × H) ⋅ normal(m)
    sum((E × H) .* normal(m))
end
function flux(u, m::PointCloudMonitorInstance)
    @unpack n = m
    E = [[field(u, k)[v...] for v = eachcol(m.roi[k])] for k = keys(u[:E])]
    H = [[field(u, k)[v...] for v = eachcol(m.roi[k])] for k = keys(u[:H])]

    dot.(stack(E × H) |> eachrow, eachcol(n))
end

"""
    function power(m::MonitorInstance, u)

total power (Poynting flux) passing thru monitor surface
"""
function power(u, m::MonitorInstance)
    # @assert ndims(m) == 2
    m.v * mean(flux(u, m))
end
power(u, m::PointCloudMonitorInstance) = flux(u, m) ⋅ m.w
# power(m, u) = sum(sum(pf([u[i...] for (u, i) = zip(u, collect(values(m.i)))]) .* normal(m)))

function monitors_on_box(c, L)
    ox, oy, oz = c
    lx, ly, lz = L
    rx, ry, rz = L / 2
    [
        Monitor([ox - rx, oy, oz], [0, ly, lz], [-1, 0, 0]),
        Monitor([ox + rx, oy, oz], [0, ly, lz], [1, 0, 0]),
        Monitor([ox, oy - ry, oz], [lx, 0, lz], [0, -1, 0]),
        Monitor([ox, oy + ry, oz], [lx, 0, lz], [0, 1, 0]),
        Monitor([ox, oy, oz - rz], [lx, ly, 0,], [0, 0, -1,]),
        Monitor([ox, oy, oz + rz], [lx, ly, 0,], [0, 0, 1,]),
    ]
end

function solve(prob, model=nothing; autodiff=true, history=nothing, comprehensive=true, verbose=false, plotpath=nothing, kwargs...)
    @unpack dx, dt, u0, field_padding, geometry_padding, subpixel_averaging, source_instances, monitor_instances, transient_duration, steady_state_duration, d = prob
    # if isnothing(geometry)
    # end

    p = prob.geometry
    mask = model[1]()
    f = design_config.fill.ϵ
    v = design_config.void.ϵ
    # for (f, v) = zip(design_config.fill, design_config.void)
    a = (v .* (1 - mask) + f .* mask)
    ϵ = place(p[:ϵ], ((designs[1].bbox[1] - origin) / dx) + 1, a; replace=true) |> F

    # p = cpu(p)
    p = apply(geometry_padding, (; ϵ, μ=p.μ, σ=p.σ, σm=p.σm))
    p = apply(subpixel_averaging, p)
    geometry = p
    # p = gpu(p)

    Δ = [transient_duration, steady_state_duration]
    T = cumsum(Δ)
    Enames = keys(u0.E)
    Hnames = keys(u0.H)
    # extrema(abs.(prob.source_instances[1]._g.Jy))

    # if save
    _update = !autodiff && !save ? update! : update
    h = []

    # run simulation
    u = reduce(0:dt:T[1], init=deepcopy(u0)) do u, t
        # save && push!(h, u)
        _update(u, p, t, dx, dt, field_padding, source_instances;)
    end

    u, mode_fields, total_powers = reduce(T[1]+dt:dt:T[2], init=(u, 0, 0)) do (u, mode_fields, tp), t
        # save && push!(h, u)
        mode_fields_ = [
            [begin
                E = dict([k => u[k, m] for k = Enames])
                H = dict([k => u[k, m] for k = Hnames])
                (; E, H)
            end * cispi(-2t / λ) for λ = m.wavelength_modes |> keys]
            for m = monitor_instances
        ]
        tp_ = map(monitor_instances) do m
            E = [u[k, m] for k = Enames]
            H = [u[k, m] for k = Hnames]
            mean(sum((E × H) .* normal(m))) * area(m)
        end

        (
            _update(u, p, t, dx, dt, field_padding, source_instances),
            mode_fields + dt / Δ[2] * mode_fields_,
            tp + dt / Δ[2] * tp_,
        )
    end

    v = map(mode_fields, monitor_instances) do v, m
        map(v, m.wavelength_modes |> keys) do u, λ
            E = values(u.E)
            H = values(u.H)
            if d == 2
                if polarization == :TE
                    # global E, H
                    Ex, Hy, Ez = invreframe(frame(m), vcat(E, H))
                    Ex += 0real(Ez[1])
                    Hy += 0real(Ez[1])
                    _mode = (; Ex, Hy, Ez)
                else
                    Hx, Ey, Hz = invreframe(frame(m), vcat(H, E))
                    Hx += 0real(Hz[1])
                    Ey += 0real(Hz[1])
                    _mode = (; Hx, Ey, Hz)
                end
            elseif d == 3
                Ex, Ey, Ez, = invreframe(frame(m), E)
                Hx, Hy, Hz = invreframe(frame(m), H)
                _mode = (; Ex, Ey, Ez, Hx, Hy, Hz)
            end
            _mode = keepxy(_mode)
            c = mode_decomp.(m.wavelength_modes[λ], (_mode,), dx)
            fp = [abs(v[1])^2 for v = c]
            rp = [abs(v[2])^2 for v = c]
            _mode, c, fp, rp
        end
    end
    modes = [[v[1] for v = v] for v in v]
    mode_coeffs = [[v[2] for v = v] for v in v]
    forward_mode_powers = [[v[3] for v = v] for v in v]
    reverse_mode_powers = [[v[4] for v = v] for v in v]

    fields = u
    if verbose
        @show forward_mode_powers, reverse_mode_powers, total_powers
    end
    if !isnothing(plotpath)

    end
    if comprehensive
        return (; fields, geometry, modes, mode_coeffs, forward_mode_powers, reverse_mode_powers, total_powers)
    end
    forward_mode_powers
end

function shorten_key(k)
    s = split(k, ",")
    p1, p2 = port_number.(s)
    mn1, mn2 = mode_number.(s)
    if mn1 == mn2 == 0
        return "$p1,$p2"
    end
    return nothing
end
function simplify_sparams(s)
    k = sort(keys(s))
    k = k[round((length(k) + 1) / 2)]
    dict([shorten_key(k) => v for (k, v) = pairs(s[k]) if !isnothing(shorten_key(k))])
end
function sparam_family(sparams)
    # sparams = simplify_sparams(detailed_sparams)
    tparams = Porcupine.apply(abs2, sparams)
    # detailed_tparams = Porcupine.apply(abs2, detailed_sparams)
    # sparam_phasors = Porcupine.apply(sparams) do z
    #     (mag=abs(z), phase=angle(z))
    # end
    # println(tparams)
    # sparams = apply(reim, sparams)
    sol = (; sparams, tparams,)# detailed_sparams, detailed_tparams)#sparam_phasors)
end
function port_number(port)
    s = split(string(port), "@")[1]
    if s[1] == 'o'
        s = s[2:end]
    end
    return parse(Int, s)
end

function mode_number(port)
    l = split(string(port), "@")
    return if length(l) == 1
        0
    else
        parse(Int, l[2])
    end
end


# function longname(s):
#     o, i = s.split(",")
#     po, pi = port_number(o), port_number(i)
#     mo, mi = mode_number(o), mode_number(i)
#     return f"o{po}@{mo},o{pi}@{mi}"

using CairoMakie
using BSON: @save, @load
using DifferentialEquations, OrdinaryDiffEq, ComponentArrays, UnPack, LinearAlgebra, Random, DiffEqFlux

# using Jello
using Images
include("startup.jl")
include("../Porcupine.jl/src/del.jl")
include("../Jello.jl/src/Base.jl")
F = Float32
include("utils.jl")
include("setup.jl")
include("plotstep.jl")

Random.seed!(1)

train = true
train = false
@load "waveguide_bend.bson" mask design_start design_dims dx
# heatmap(mask)
T = 5.0f0
tspan = (0.0f0, T)
microns_dx = dx
dx = 1.0f0 / 16
dt = dx / 2
saveat = 1 / 16.0f0
solver = Euler()

L = size(mask) .* microns_dx

λ = 1.28f0
L = L ./ λ
l, _ = L
common_left_pad_amount = (57.5f0 / 108) * l
dims = round.(Int, L ./ dx)
design_dims = round.(Int, design_dims .* microns_dx ./ λ ./ dx)
design_start = 1 .+ round.(Int, (design_start .- 1) .* microns_dx ./ λ ./ dx)
mask = imresize(mask, dims)
model = Blob(design_dims, 0.2f0 / dx)
if train
end
# heatmap(mask)
polarization = :TM
ϵ1 = 2.25f0
ϵ2 = 12.25f0
b = place(mask, model(), design_start)
ϵ = ϵ2 * b + ϵ1 * (1 .- b)
# extrema(ϵ)

boundaries = []
monitors = [Monitor([0.0f0l, common_left_pad_amount], [:Ez, :Hx, :Hy]), Monitor([common_left_pad_amount, 0.0f0], [:Ez, :Hx, :Hy])]
sources = [GaussianBeam(t -> cos(F(2π) * t), 0.05f0, (0.0f0, common_left_pad_amount), -1; Ez=1)]
@unpack geometry_padding, field_padding, source_instances, monitor_configs, save_idxs, fields =
    setup(boundaries, sources, monitors, L, dx, polarization; F)

static_geometry = (; μ=ones(Int, dims), σ=zeros(Int, dims), σm=zeros(Int, dims))
geometry = (; ϵ, static_geometry...)
geometry = apply(geometry_padding, geometry)
@unpack ϵ, μ, σ, σm = geometry
_dims = size(ϵ)

p = comp_vec((:ϵ, :μ, :σ, :σm), Array.((ϵ, μ, σ, σm))...,)

∇ = Del([dx, dx])
function dudt(u, p, t)
    ϵ, μ, σ, σm = eachslice(reshape(p, _dims..., 4), dims=3)
    # @unpack ϵ, μ, σ, σm=m.p
    ϵ, μ, σ, σm = [ϵ], [μ], [σ], [σm]

    u = apply(source_instances, u, u.t)
    E, H, J = group.((u,), [:E, :H, :J])

    H_ = apply(field_padding, (; Hx=u.Hx, Hy=u.Hy);)
    dEzdt, = (∇ × H_) / ϵ
    # dEzdt, = (∇ × H_ - σ * E - J) / ϵ
    E += [dEzdt * dt]

    E_ = apply(field_padding, (; Ez=E[1]);)
    dHxdt, dHydt = -(∇ × E_ + σm * H) / μ
    dJzdt = zeros(Int, size(dEzdt))
    # ComponentArray((; Ez, Hx, Hy, Jz,))
    comp_vec((:Ez, :Hx, :Hy, :Jz, :t), dEzdt, dHxdt, dHydt, dJzdt, 1.0f0,)
end

fields = ComponentArray(merge(u0, (; t=F(0))))
u0 = fields
tstops = range(tspan..., length=8 + 1)
callback = train ? nothing : PresetTimeCallback(tstops, plotstep)
prob_neuralode = ODEProblem(dudt, u0, tspan, p,)
function loss(model; withsol=false)
    b = place(mask, model(), design_start)
    ϵ = ϵ2 * b + ϵ1 * (1 .- b)
    geometry = (; ϵ, static_geometry...)
    geometry = apply(geometry_padding, geometry)
    # @unpack ϵ, μ, σ, σm = geometry

    # p = comp_vec((:ϵ, :μ, :σ, :σm), Array(ϵ), Array(μ), Array(σ), Array(σm),)
    p = reduce(vcat, vec.(values(geometry)))
    # global sol = Array(solve(prob_neuralode, solver; dt, p,
    sol = solve(
        prob_neuralode,
        solver;
        dt,
        p,
        callback,
        saveat,
        sensealg=QuadratureAdjoint(autojacvec=ZygoteVJP(), abstol=1e-2,
            reltol=1e-1),
    )

    t = (round(Int, (T - 1) / saveat):round(Int, T / saveat)) .+ 1
    res = field(Array(sol), monitor_configs[2], t)
    # t = T-1:dt:T
    # res = field(sol, monitor_configs, t)

    l = 1mean(res.Ez .* res.Hx)

    withsol ? (l, sol) : l
end


if train
    # g = Zygote.gradient(loss, model)[1]
    # error()
    opt = Adam(0.1)
    # opt = AdaGrad()
    opt_state = Flux.setup(opt, model)

    # fig = Figure()
    # heatmap(fig[1, 1], m(0), axis=(; title="start of training"))
    for i = 1:2
        global sol, l, dldm
        l, (dldm,) = withgradient(loss, model,)
        # (l, sol), (dldm,) = withgradient(loss, model,)
        Flux.update!(opt_state, model, dldm)
        println("$i $l")
    end
    # heatmap(fig[1, 2], m(0), axis=(; title="end of training"))
else

    l, sol = loss(model; withsol=true)
end
# display(fig)


using CairoMakie
using CairoMakie: Axis
# t = 0.0f0:dt:T
t = range(0, T, length=size(sol, 2))
fig = Figure()
for i = 1:2
    ax = Axis(fig[i, 1], title="")
    m = field(sol, monitor_configs[i], :)
    E, H = if i == 1
        m.Ez, m.Hy
    elseif i == 2
        m.Ez, m.Hx
    end
    lines!(ax, t, E)
    lines!(ax, t, H)
    lines!(ax, t, H .* E)
end
display(fig)

# try
#     using GLMakie
#     using GLMakie: volume
#     global gl = true
# catch e
# using CairoMakie
global gl = false

° = π / 180
function _plot!(g, a, ; colorrange=nothing, title="", colormap=:seismic, algorithm=nothing,
    azimuth=75°, elevation=75°,
    kw...)
    if ndims(a) == 2 || !gl
        if isnothing(colorrange)
            colorrange = 2extrema(a)
        end
        if ndims(a) == 3
            println("3D array: plotting middle slice")
            title *= " (middle slice of 3D array)"
            a = a[:, :, round(Int, size(a, 3) / 2)]
        end
        aspect = size(a, 1) / size(a, 2)
        ax, pl = heatmap(g[1, 1], real(a); axis=(; kw..., title, aspect), colormap, colorrange=colorrange)
    else
        if isnothing(colorrange)
            colorrange = extrema(a) * 0.1
        end
        ax, pl = volume(g[1, 1], real(a), ; axis=(; kw..., type=Axis3, title,), colormap, colorrange, algorithm)
        ax.elevation[] = elevation
        ax.azimuth[] = azimuth
    end
    if diff(collect(extrema(a)))[1] > 0
        Colorbar(g[1, 2], pl)
    end
end
function quickie(sol; kw...)
    @unpack fields, geometry = sol
    fig = Figure()
    fields = (; H=(; Hz=fields.H.Hz))
    geometry = (; ϵ=geometry.ϵ)
    colorrange = (-1, 1) .* maximum(maximum.(a -> abs.(real(a)), flatten(fields)))
    colormap = :seismic
    algorithm = :absorption
    i = 1
    for k1 = keys(fields)
        j = 1
        for (k2, a) = pairs(fields[k1])
            g = fig[i, j]
            title = string(k2)
            _plot!(g, a, ; title, colormap, colorrange, algorithm, kw...)

            j += 1
        end
        i += 1
    end
    if !isnothing(geometry)
        j = 1
        for (k2, a) = pairs(geometry)
            g = fig[i, j]
            title = string(k2)
            _plot!(g, a, ; title, algorithm=:mip, kw...)

            j += 1
        end
    end
    return fig
end

"""
    function update!(u, p, t, field_padding, source_instances)
    function update!(u1, u, p, t, field_padding, source_instances)

Updates fields for 3d. Please use `update` instead of `update!` when doing AD. Mutating `update!` Writes new fields either onto old fields or into buffer arrays u1
"""
function update!(u1, u, p, t, dx, dt, field_padding, source_instances)
    @unpack ϵ, μ, σ, σm = p
    # ϵ, μ, σ, σm = Ref.([ϵ, μ, σ, σm])

    @unpack E, H, J = u
    J0 = deepcopy(J)
    E1 = u1[:E]
    H1 = u1[:H]
    J = apply(source_instances, t; J...)
    d = ndims(first(values(E)))
    ∇ = StaggeredDel(fill(dx, d))

    # first update E
    H = mark(field_padding, H)
    dEdt = (∇ × H - σ * E - J) / ϵ

    for (a, b, c) = zip(values(E1), values(E), values(dEdt))
        a .= b + c * dt
    end
    E = apply!(field_padding, E1)
    H = unmark(H)

    # then update H
    E = mark(field_padding, E)
    dHdt = -(∇ × E + σm * H) / μ

    for (a, b, c) = zip(values(H1), values(H), values(dHdt))
        a .= b + c * dt
    end
    H = apply!(field_padding, H1)
    E = unmark(E)

    (; E, H, J=J0)
    # u1
end
update!(u, p, t, dx, dt, field_padding, source_instances) = update!(u, u, p, t, dx, dt, field_padding, source_instances)

"""
    function update(u, p, t, field_padding, source_instances)
    
Updates fields for 3d in a manner amenable to AD. See also Mutating `update!`
        """
function update(u, p, t, dx, dt, field_padding, source_instances)
    @unpack ϵ, μ, σ, σm = p
    # ϵ, μ, σ, σm = Ref.([ϵ, μ, σ, σm])
    @unpack E, H, J = u
    J0 = deepcopy(J)
    J = apply(source_instances, t, J)
    d = ndims(first(values(E)))
    ∇ = StaggeredDel(fill(dx, d))

    # first update E
    # H = mark(field_padding; H...)
    H = mark(field_padding, H)
    # @info typeof(E)
    dEdt = (∇ × H - σ * E - J) / ϵ
    # @info typeof(dEdt)
    # @show extrema((values(dEdt))[2]), extrema(J.Jy)
    E = E + dEdt * dt

    E = apply(field_padding, E)
    H = unmark(H)

    # then update H
    E = mark(field_padding, E)
    dHdt = -(∇ × E + σm * H) / μ
    H = H + dHdt * dt

    H = apply(field_padding, H)
    E = unmark(E)

    # [E, H]
    # dict([:E => E, :H => H, :J => J0])
    (; E, H, J=J0)
end
update! = update!
# Flux.trainable(m::PaddedArray) = (; a=m.a)

function normalize_mode(m, dx)
    @unpack Ex, Hy, = m
    # @unpack Ex, Hy, Ez = m
    p = real(Ex ⋅ Hy) * dx^ndims(Ex) / 2
    m / √p
    # (; Ex=Ex / √p, Hy=Hy / √p, Ez=Ez / √p)
end

function keepxy(mode)
    dict([k => mode[k] for k in keys(mode) if string(k)[2] ∈ ('x', 'y')])
end


# function mode_decomp(m, u::AbstractVector, dx)
#     Ex,Hy,Hz
function mode_decomp(m, u, dx)

    polarization = get_polarization(u)
    m = normalize_mode(m, dx)
    if polarization == :TM
        ap_TE = am_TE = 0
    else
        Ex = m.Ex ⋅ field(u, :Ex) / norm(m.Ex)^2
        Hy = m.Hy ⋅ field(u, :Hy) / norm(m.Hy)^2
        ap_TE = Hy + Ex
        am_TE = Hy - Ex
    end
    if polarization == :TE
        ap_TM = am_TM = 0
    else
        Hx = m.Hx ⋅ field(u, :Hx) / norm(m.Hx)^2
        Ey = m.Ey ⋅ field(u, :Ey) / norm(m.Ey)^2
        am_TM = Ey + Hx
        ap_TM = Ey - Hx
    end
    # [ap_TE + ap_TM, am_TE + am_TM]
    if polarization == :TM
        return [ap_TM, am_TM]
    end
    if polarization == :TE
        return [ap_TE, am_TE]
    end
    return [ap_TE, am_TE]
end


function collapse_mode(m, ϵ)
    @unpack Ex, Ey, Ez, Hx, Hy, Hz = m
    E = sqrt.(abs2.(Ex) + abs2.(Ey) + abs2.(Ez))
    Ex, Ez, Hy = map([Ex, Ez, Hy]) do a
        mean(a, dims=2) |> vec
    end
    # (; Ex, Hy, Ez), sum(E .* ϵ, dims=2) ./ sum(E, dims=2) |> vec
    (; Ex, Hy, Ez), maximum.(eachrow(ϵ))
end

function insert(a, i, v)
    if i == 1
        [v, a...]
    else
        [a[1:i-1]..., v, a[i:end]...]
    end
end
function reframe(frame, u, inv=false)
    # p = = 0
    d = ndims(u[1]) + 1
    p = findfirst.(x -> abs(1 - abs(x)) < 1.0f-3, frame)
    signs = sign.(getindex.(frame, p))
    invdims = findall(isequal(-1), signs) |> Tuple
    if inv
        sz = size(u[1])
        sz = insert(sz, p[3], 1)
        if d == 2
            sz = insert(sz, p[2], 1)
            # (@assert p[2] == 3)
        end
        sz = Tuple(sz)

        u = [reshape(a, sz) for a in u]
        u = permutedims.(u, (p,))
        u = u[p]

        u = [s * reverse(a, dims=invdims) for (s, a) in zip(signs, u)]
        u = dropdims.(u, dims=Tuple(d:3))
        # p = invperm(p)
    else
        u = [reshape(a, size(a)..., fill(1, 3 - ndims(a))...) for a in u]
        # invpermute!(u, perm)
        u = [s * reverse(a, dims=invdims) for (s, a) in zip(signs, u)]
        u = [u[i] for i = invperm(p)]
        u = permutedims.(u, (invperm(p),))
    end
end
invreframe(frame, u) = reframe(frame, u, true)

function place_mask(a, o, mask, c=1)
    o = round.(o)
    _mask = (mask / maximum(abs, mask)) .> 0.5
    _ksam = .!(_mask)
    a = a .* pad(_ksam, true, o - 1, size(a) .- size(_ksam) - o + 1)
    place(a, o, _mask .* mask,)
end
d2(x) = round.(x, sigdigits=2)

function apply!(p, kw)
    dict([k => apply!(p[k], kw[k]) for k = keys(kw)])
    # [apply(p[k], v) for (k, v) = pairs(kw)]
end
function apply!(p; kw...)
    apply!(p, kw)
end
# apply!(p, x::Number) = x
apply(p, x::Number) = apply(p, x * ones(typeof(x), p.default_size))

function apply(p, kw)
    dict([k => apply(p[k], kw[k]) for k = keys(kw)])
    # [apply(p[k], v) for (k, v) = pairs(kw)]
end
function apply(p; kw...)
    apply(p, kw)
end

function apply(d::Dictlike, a::AbstractArray)
    dict([k => apply(d[k], a) for k = keys(d)])
end

function apply(i::AbstractVector{<:AbstractRange}, a::AbstractArray)
    getindex(a, i...)
end
function mark(p, kw)
    dict([k => mark(p[k], kw[k]) for k = keys(kw)])
end
function mark(p; kw...)
    # [k => mark(p[k], kw[k]) for k = keys(kw)]
    # [mark(p[k], kw[k]) for k = keys(kw)]
    dict([k => mark(p[k], kw[k]) for k = keys(kw)])
end
function unmark(kw)
    dict([k => Array(kw[k]) for k = keys(kw)])
end
function unmark(; kw...)
    dict([k => Array(kw[k]) for k = keys(kw)])
    # [Array(kw[k]) for k = keys(kw)]
    # [k => Array(kw[k]) for k = keys(kw)]
end
function mark(v::AbstractVector, a)
    l = sum(v) do p
        p.l
    end
    r = sum(v) do p
        p.r
    end
    PaddedArray(a, l, r)
end

# Flux.gpu(d::T) where {T<:Dictlike} = dict(T, [k => Flux.gpu(d[k]) for k = keys(d)])
# Flux.cpu(d::T) where {T<:Dictlike} = dict(T, [k => Flux.cpu(d[k]) for k = keys(d)])

# Base.Float16(x) = f16(x)
# Base.Float32(x) = f32(x)


footer = "Suppress this message by verbose=false\n2024 (c) Paul Shen at Luminescent AI\n<pxshen@alumni.stanford.edu>"

function solve(prob; autodiff=true, history=nothing, comprehensive=true, verbose=false, plotpath=nothing, _time=true, kwargs...)
    t0 = ignore() do
        time()
    end
    @unpack dx, dt, u0, field_padding, geometry_padding, subpixel_averaging, source_instances, geometry, monitor_instances, transient_duration, steady_state_duration, d, n = prob

    sz = size(first(values(geometry)))
    points = prod(sz)
    steps = (transient_duration + steady_state_duration) / dt |> round
    println("$points points x $steps steps = $(points*steps) point-steps")
    p = geometry
    _gpu = isa(first(values(p)), AbstractGPUArray)
    p = apply(geometry_padding, p)
    # global aaaaaaaaa = p
    # if _gpu
    #     ignore() do
    #         p = gpu(p)
    #     end
    # end
    p = apply(subpixel_averaging, p)
    global aaaaaaaada = p


    Δ = [transient_duration, steady_state_duration]
    T = cumsum(Δ)
    Enames = keys(u0.E)
    Hnames = keys(u0.H)
    # extrema(abs.(prob.source_instances[1]._g.Jy))

    # if save
    _update = !autodiff ? update! : update
    h = []

    # run simulation
    u = reduce(0:dt:T[1], init=deepcopy(u0)) do u, t
        # save && push!(h, u)
        _update(u, p, t, dx, dt, field_padding, source_instances;)
    end

    u, mode_fields, total_powers = reduce(T[1]+dt:dt:T[2], init=(u, 0, 0)) do (u, mode_fields, tp), t
        # save && push!(h, u)
        mode_fields_ = [
            [
                begin
                    # λ = dispersion_compensation(dx, dt, n, λ)
                    # E = dict([k => u[k, m] for k = Enames])
                    # H = dict([k => u[k, m] for k = Hnames])
                    # (; E, H)
                    E = [u[k, m] |> F for k = Enames]
                    H = [u[k, m] |> F for k = Hnames]
                    # global aaab, bbbb = E, H
                    [E, H] * cispi(-2t / λ)
                end for λ = m.wavelength_modes |> keys]
            for m = monitor_instances
        ]
        tp_ = map(monitor_instances) do m
            E = [u[k, m] for k = Enames]
            H = [u[k, m] for k = Hnames]
            mean(sum((E × H) .* normal(m))) * area(m)
        end

        (
            _update(u, p, t, dx, dt, field_padding, source_instances),
            mode_fields + dt / Δ[2] * mode_fields_,
            tp + dt / Δ[2] * tp_,
        )
    end

    v = map(mode_fields, monitor_instances) do mf, m
        map(mf, values(m.wavelength_modes)) do u, wm
            # E = values(u.E)
            # H = values(u.H)
            E, H = u
            if d == 2
                if polarization == :TE
                    # global E, H
                    Ex, Hy, Ez = invreframe(frame(m), vcat(E, H))
                    Ex += 0sum(Ez[1:2])
                    Hy += 0sum(Ez[1:2])
                    # end
                    _mode = (; Ex, Hy, Ez)
                else
                    Hx, Ey, Hz = invreframe(frame(m), vcat(H, E))
                    Hx += 0real(Hz[1])
                    Ey += 0real(Hz[1])
                    _mode = (; Hx, Ey, Hz)
                end
            elseif d == 3
                Ex, Ey, Ez, = invreframe(frame(m), E)
                Hx, Hy, Hz = invreframe(frame(m), H)
                _mode = (; Ex, Ey, Ez, Hx, Hy, Hz)
            end
            # _mode = keepxy(_mode)
            c = mode_decomp.(wm, (_mode,), dx)
            fp = [abs(v[1])^2 for v = c]
            rp = [abs(v[2])^2 for v = c]
            _mode, c, fp, rp
        end
    end
    modes = [[v[1] for v = v] for v in v]
    mode_coeffs = [[v[2] for v = v] for v in v]
    forward_mode_powers = [[v[3] for v = v] for v in v]
    reverse_mode_powers = [[v[4] for v = v] for v in v]

    fields = u
    if verbose
        @show forward_mode_powers, reverse_mode_powers, total_powers
    end
    if !isnothing(plotpath)

    end
    # if _time
    #     ignore() do
    #         println("simulation took: ", time() - t0)
    #     end
    # end
    return (; fields, geometry, modes, mode_coeffs, forward_mode_powers, reverse_mode_powers, total_powers)
end

println("starting optimization... first iter will be slow due to compilation.")
stop = false
img = nothing
for i = 1:maxiters
    global img = if virgin
        global virgin = false
        "before.png"
    elseif i == maxiters || stop
        "after.png"
    else
        img
    end
    @time global l, (dldm,) = withgradient(model) do m
        global sparams = write_sparams(m; img, autodiff=true)
        params = if target_type == "sparams"
            sparams
        else
            Porcupine.apply(abs2, sparams)
        end
        loss(params)
        # abs(sparams[1].mode_coeffs[2][1][1][1])

    end
    if stop
        break
    end
    if i == 1
        global best0 = best = l
        global sparams0 = deepcopy(sparams)
    end
    # l < 0 && break
    Flux.update!(opt_state, model, dldm)
    if l < best
        global best = l
    end
    if l < minloss
        # @info "Loss below threshold, stopping optimization."
        println("Loss below threshold, stopping optimization.")
        global stop = true
        global img = "after.png"
    end
    if i % 15 == 0
        if best - best0 > -0.01
            println("Loss stagnating, stopping optimization.")
            global stop = true
        else
            global best0 = best
        end
    end
    println("$i loss $l\n")
end
# @info "Done in $(time() - t0) ."
println("Done in $(time() - t0) .")
for (i, (m, d)) = enumerate(zip(model, design_configs))
    Images.save(joinpath(path, "design$i.png"), Gray.(m() .< 0.5))
end
sol = (;
    before=sparam_family(sparams0),
    after=sparam_family(sparams),
    design_configs,path,dx,
    designs=[m().>.5 for m in model],
)
# @save "$path/sol.json" sol
open("$(path)/sol.json", "w") do f
write(f, json(sol))
end

using UnPack, LinearAlgebra, Random, Jello, StatsBase, ImageTransformations, Meshes, CoordinateTransformations, Functors, DataStructures, GPUArraysCore
using Meshes: Sphere
using ArrayPadding: left, right
using Zygote: bufferfrom, Buffer, ignore_derivatives
using Zygote, Flux#,NNlib
# Random.seed!(1)

using Porcupine: keys, values
using Porcupine
using ArrayPadding
# include("../../Porcupine.jl/src/main.jl")
# include("../../ArrayPadding.jl/src/main.jl")
# include("../../Jello.jl/src/main.jl")
include("constants.jl")
include("utils.jl")
include("modes.jl")
include("update.jl")
include("boundaries.jl")
include("sources.jl")
include("monitors.jl")
include("geometry.jl")
include("setup.jl")
include("solve.jl")
include("photonics.jl")
include("gpu.jl")
include("format.jl")
include("dispersion.jl")
# ]add UnPack, LinearAlgebra, Random, StatsBase, ImageTransformations, Functors, DataStructures,Porcupine,Jello, ArrayPadding,Zygote, GPUArraysCore

function vec2cmat(v, dims)
    a = reshape(v, dims..., 2)
    complex.(a[:, :, 1], a[:, :, 2])
end
function cmat2vec(m)
    v = vec(m)
    vcat(real(v), imag(v))
end
function f(x)
    model.a .= vec2cmat(x, size(model.a))
end

function g!(storage, x)
    storage .= cmat2vec(g)
end
function fg!(storage, x)
    storage .= cmat2vec(g)
    l
end
x0 = cmat2vec(model.a)
od = OnceDifferentiable(f, g!, fg!, x0)
minimizer(optimize(od, x0, LBFGS(), iterations=nepochs))

function dispersion_compensation(dx::T, dt, n, λ,) where {T}
    λ0 = λ
    c = 1 / n
    λ /= n
    k = 2π / λ
    w = 2 / dt * asin(dt / dx * c * sin(dx * k / 2))
    λ = 2π / w * c
    λ *= n

    a = 0.5
    @show λ0, λ, n
    (a * λ + (1 - a) * λ0) |> T
end

function calibrate_mode(mode, ϵmode, dx, ; F=Float32, verbose=false, name="", kwargs...)
    mode, ϵmode, dx, = (mode, ϵmode, dx,) |> F
    d = ndims(ϵmode) + 1

    source_margin, port_source_offset, mode_margin = whole.((SOURCE_MARGIN, PORT_SOURCE_OFFSET, MODE_MARGIN), dx)
    l0 = 2
    l = l0 + port_source_offset + source_margin

    # wm = wwg / 2
    # w = 2wm + wwg
    # sz = (round(Int, l / dx), round(Int, w / dx))
    L = [size(ϵmode) * dx...]
    sz = (round(l / dx), size(ϵmode)...)

    ϵ = stack(fill(ϵmode, sz[1]))
    if d == 2
        ϵ = ϵ'
        ϵ = pad(ϵ, :replicate, (0, round(mode_margin / dx)))
    else
        ϵ = permutedims(ϵ, (3, 1, 2))
    end
    sz = size(ϵ)
    l, w, = sz * dx

    normal = [1, zeros(d - 1)...]
    tangent = [0, -1, zeros(d - 2)...]
    m = [ModalMonitor(mode, [x, w / 2], normal, tangent, L) for x = range(0, l0, 3) + source_margin + port_source_offset]
    s = ModalSource(t -> cispi(2t), mode, [source_margin, w / 2], -normal, tangent, L;)

    prob = setup([], [s], m, dx, sz; F, ϵ, verbose)
    sol = solve(prob)

    @unpack fields, modes, forward_mode_powers = sol
    mode = modes[1][1]
    power = forward_mode_powers[1][1][1]
    @show forward_mode_powers
    quickie(sol)|> display
    global ret = (; mode, power, sol)

end
